local waitTable = {};
local waitFrame = nil;

-- functions
function CleanUI_OnLoad(self)
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffNirriti's |rCleanUI loaded.", 1.0, 1.0, 1.0, 1, 10);
 	    
 	-- max. Kameradistanz erhhen
	SetCVar("CameraDistanceMax", 50);
	
    -- register for addon messages
    RegisterAddonMessagePrefix("CleanUI");
		
	-- initialisieren
    CleanUI_RegisterEvents(self);
    CleanUI_HookEvents();
	CleanUI_InitSlashCommandHandler();
end

function CleanUI_InitSlashCommandHandler()

	SLASH_CLEANUI1 = "/cui";
  	SLASH_CLEANUI2 = "/cleanui";
  	SlashCmdList["CLEANUI"] = function(msg)
		CleanUI_SlashCommandHandler(msg);
	end
end

function CleanUI_SlashCommandHandler(msg)	
	if (msg == "reload") then
	 	ReloadUI();
	elseif (msg == "gc") then
        CleanUI_GC();
	elseif (msg == "versionupdate" or msg == "vu") then
        CleanUIData.VERSION = nil;
        CleanUIConfig_VersionUpdate();
	elseif (msg == "reset") then
	 	CleanUIConfig_Reset();
	elseif (string.find(msg, "framestack") == 1) then
	    GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
        GameTooltip:SetFrameStack(true); 
    elseif (string.find(msg, "bag on") == 1) then
        CleanUIData.USE_BIGBAG = 1;
    elseif (string.find(msg, "bag off") == 1) then
        CleanUIData.USE_BIGBAG = 0;
    elseif (string.find(msg, "fake") == 1) then
        local message = string.sub(msg, 6);
        CleanUI_XXXXX(message);
	end
	
	CleanUIConfig_ReloadConfig();
end

function CleanUI_RegisterEvents(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("ADDON_LOADED"); 
	
	self:RegisterEvent("MODIFIER_STATE_CHANGED"); 
	
	self:RegisterEvent("MERCHANT_SHOW");	
    self:RegisterEvent("BANKFRAME_OPENED");
    
    self:RegisterEvent("BAG_UPDATE");
    
	self:RegisterEvent("MINIMAP_ZONE_CHANGED");
	self:RegisterEvent("WORLD_MAP_UPDATE");
	
	self:RegisterEvent("ZONE_CHANGED");
	self:RegisterEvent("ZONE_CHANGED_INDOORS");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
 	
 	self:RegisterEvent("PLAYER_DEAD");
	self:RegisterEvent("UPDATE_INVENTORY_ALERTS");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED");
	
	self:RegisterEvent("UPDATE_PENDING_MAIL");	
	self:RegisterEvent("MAIL_CLOSED");
	
	self:RegisterEvent("PARTY_MEMBERS_CHANGED");
	self:RegisterEvent("PARTY_MEMBER_ENABLE");
	self:RegisterEvent("PARTY_MEMBER_DISABLE");
	
	self:RegisterEvent("PLAYER_XP_UPDATE");
	self:RegisterEvent("CHAT_MSG_ADDON");
	
	self:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE");	
	self:RegisterEvent("UNIT_THREAT_LIST_UPDATE");
	
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("PLAYER_FOCUS_CHANGED");
	self:RegisterEvent("PLAYER_FLAGS_CHANGED");
	
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("UNIT_HEALTH");
	self:RegisterEvent("UNIT_COMBAT");
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	
	self:RegisterEvent("UNIT_SPELLCAST_START");
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	
	self:RegisterEvent("PLAYER_REGEN_ENABLED");	
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	
	self:RegisterEvent("RAID_TARGET_UPDATE");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
	
	self:RegisterEvent("CVAR_UPDATE");
	
	self:RegisterEvent("CALENDAR_UPDATE_PENDING_INVITES");
	
	self:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
	self:RegisterEvent("UPDATE_SHAPESHIFT_USABLE");
	
	self:RegisterEvent("UNIT_ENTERED_VEHICLE");
	self:RegisterEvent("UNIT_EXITED_VEHICLE");
	
	self:RegisterEvent("EQUIPMENT_SETS_CHANGED");
	self:RegisterEvent("EQUIPMENT_SWAP_FINISHED");
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
	
	self:RegisterEvent("ACHIEVEMENT_EARNED");
	self:RegisterEvent("PLAYER_LEVEL_UP");	
		
	self:RegisterEvent("ARTIFACT_UPDATE");
	self:RegisterEvent("ARTIFACT_HISTORY_READY");
	self:RegisterEvent("ARTIFACT_COMPLETE");
	self:RegisterEvent("ARTIFACT_DIG_SITE_UPDATED");	
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	
	self:RegisterEvent("UPDATE_BINDINGS");
	
	--self:RegisterAllEvents();
end

function CleanUI_HookEvents()
    CleanUI_ActionBarsHookEvents();
    CleanUI_BagsHookEvents();
    CleanUI_ChatHookEvents();
    CleanUI_GuildHookEvents();
    CleanUI_XpFrameHookEvents();
    CleanUI_QuestHookEvents();
    CleanUI_DeBuffsHookEvents();
    CleanUI_CastingBarHookEvents();
    CleanUI_ReputationHookEvents();
    CleanUI_RaidHookEvents();
    CleanUI_EquipmentSetsHookEvents();
    CleanUI_TalentsHookEvents();
    CleanUI_TooltipsHookEvents();
    CleanUI_NameplatesHookEvents();
    CleanUI_CharacterFrameHookEvents();
    CleanUI_UnitFramesHookEvents();
    CleanUI_DataBrokerHookEvents();
    CleanUI_MailHookEvents();
    
    CleanUIConfig_HookEvents();
    CleanUIAddons_HookEvents();
end
    
function CleanUI_OnUpdate(self, elapsed)
    CleanUI_MinimapOnUpdate(self, elapsed);
    CleanUI_CastingBarOnUpdate(self, elapsed);
    CleanUI_DeBuffsOnUpdate(self, elapsed);
    CleanUI_GuildOnUpdate(self, elapsed);
    CleanUI_UnitFramesOnUpdate(self, elapsed);
    CleanUI_ReputationOnUpdate(self, elapsed);
    CleanUI_UnitThreadOnUpdate(self, elapsed);
    CleanUI_ThreatFrameOnUpdate(self, elapsed);
    CleanUI_NameplatesOnUpdate(self, elapsed);
    CleanUI_DataBrokerOnUpdate(self, elapsed);
end

function CleanUI_OnEvent(self, event, ...)

    --cui_debug(event, "event");
    
	if (event == "ADDON_LOADED") then
		local addonName = ...;
		if (addonName == "CleanUI") then
		    CleanUI_StartDelay(CUI_START_DELAY, CleanUI_InitCommon);
		    CleanUI_StartDelay(CUI_START_DELAY, function (self) CleanUI_ReplaceAllBorderTextures("UI-Tooltip-Border", UIParent); end);
		    
        end
    end

    if (event == "ACHIEVEMENT_EARNED" or event == "PLAYER_LEVEL_UP") then
        if (CleanUIData.SCREENSHOT == 1) then
            CleanUI_TakeScreenshot();
        end
    end

    if (event == "CVAR_UPDATE") then
		--local cvar, value = ...;
		--cui_debug(value, cvar);
    end
    
    CleanUI_BagsOnEvent(self, event, ...);
    CleanUI_MinimapOnEvent(self, event, ...);
    CleanUI_MapOnEvent(self, event, ...);
    CleanUI_UnitFramesOnEvent(self, event, ...);
    CleanUI_ActionBarsOnEvent(self, event, ...);
    CleanUI_XpFrameOnEvent(self, event, ...);
    CleanUI_ChatOnEvent(self, event, ...);
    CleanUI_GuildOnEvent(self, event, ...);
    CleanUI_DeBuffsOnEvent(self, event, ...);
    CleanUI_CastingBarOnEvent(self, event, ...);
    CleanUI_QuestOnEvent(self, event, ...);
    CleanUI_CharacterFrameOnEvent(self, event, ...);
    CleanUI_UnitThreadOnEvent(self, event, ...);
    CleanUI_ThreatFrameOnEvent(self, event, ...);
    CleanUI_TooltipsOnEvent(self, event, ...);
    CleanUI_NameplatesOnEvent(self, event, ...);
    CleanUI_ReputationOnEvent(self, event, ...);
    CleanUI_RaidOnEvent(self, event, ...);
    CleanUI_DataBrokerOnEvent(self, event, ...);
    CleanUI_MailOnEvent(self, event, ...);
end

function CleanUI_TakeScreenshot()   
    CleanUI_StartDelay(1.2, Screenshot);
end

function CleanUI_StartDelay(delay, func, ...)
    if(type(delay)~="number" or type(func)~="function") then
        return false;
    end
    
    if(waitFrame == nil) then
        waitFrame = CreateFrame("Frame","CUI_WaitFrame", UIParent);
        waitFrame:SetScript("onUpdate",function (self,elapse)
            local count = #waitTable;
            local i = 1;
            
            while(i<=count) do
                local waitRecord = tremove(waitTable,i);
                local d = tremove(waitRecord,1);
                local f = tremove(waitRecord,1);
                local p = tremove(waitRecord,1);
                
                if(d>elapse) then
                    tinsert(waitTable,i,{d-elapse,f,p});
                    i = i + 1;
                else
                    count = count - 1;
                    f(unpack(p));
                end
            end
        end);
    end
    
    tinsert(waitTable,{delay,func,{...}});
    
    return true;
end

function CleanUI_InitCommon()	

    CleanUIConfig_Init();

    CleanUI_SetDefaultBackdrop(GameTooltip);
    CleanUI_SetDefaultBackdrop(ShoppingTooltip1);
    CleanUI_SetDefaultBackdrop(ShoppingTooltip2);
    CleanUI_SetDefaultBackdrop(ShoppingTooltip3);
    CleanUI_SetDefaultBackdrop(SmallTextTooltip);
    
    CleanUI_SetDefaultBackdrop(ItemRefTooltip);
    CleanUI_SetDefaultBackdrop(ItemRefShoppingTooltip1);
    CleanUI_SetDefaultBackdrop(ItemRefShoppingTooltip2);
    CleanUI_SetDefaultBackdrop(ItemRefShoppingTooltip3);
    
    CleanUI_SetDefaultBackdrop(WorldMapTooltip);
    CleanUI_SetDefaultBackdrop(WorldMapCompareTooltip1);
    CleanUI_SetDefaultBackdrop(WorldMapCompareTooltip2);
    CleanUI_SetDefaultBackdrop(WorldMapCompareTooltip3);
    
    CleanUI_MakeFrameMoveable(QuestLogFrame);
    CleanUI_MakeFrameMoveable(CharacterFrame);
    CleanUI_MakeFrameMoveable(FriendsFrame);
    --CleanUI_MakeFrameMoveable(GuildFrame);
    --CleanUI_MakeFrameMoveable(AchievementFrame);
    --CleanUI_MakeFrameMoveable(PlayerTalentFrame);
    CleanUI_MakeFrameMoveable(SpellBookFrame);
    CleanUI_MakeFrameMoveable(PVPFrame);
    CleanUI_MakeFrameMoveable(LFDParentFrame);
    
    CleanUI_CleanActionBars();
    CleanUI_CleanDeBuffs();
    CleanUI_CleanReputationWatchBar();
    CleanUI_CleanXpFrame();
    CleanUI_InitBags();
    CleanUI_InitThreatDataFrame();
    CleanUI_InitUnitFrames();
    CleanUI_InitThreatBars();
    CleanUI_InitTooltips();
    CleanUI_InitQuest();
    CleanUI_InitRaid();
    CleanUI_InitDataBroker();
    
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then 
        CleanUI_CleanMicroButtons();
    else
        CleanUI_CleanMinimap();
        CleanUI_InitMinimapButtons();
    end
    
    CleanUI_CleanMap();
    CleanUI_InitChat();
    CleanUI_InitDeBuffs();
    
    if (CleanUIData.CHANGE_CHARACTERFRAME == 1) then 
        CleanUI_InitCharacterFrame();
    end
    
    CleanUI_InitCastingBars();    
    CleanUI_InitStatusBarTexture();
end

function CleanUI_InitStatusBarTexture()

    CleanUIStatusBarExample:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);

    -- unit frames
    PlayerFrameHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PlayerFrameManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PlayerFrameAlternateManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PlayerFrameMyHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PlayerFrameOtherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);

    PetFrameHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PetFrameManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PetFrameMyHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    PetFrameOtherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);

    TargetFrameHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    TargetFrameManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    TargetFrameMyHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    TargetFrameOtherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);

    FocusFrameHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    FocusFrameManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    FocusFrameMyHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    FocusFrameOtherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    TargetFrameToTHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    TargetFrameToTManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    FocusFrameToTHealthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    FocusFrameToTManaBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    _G["CUI_PlayerAggroBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
	_G["CUI_PetAggroBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
		
	-- party unit frames
    for i=1, 4, 1 do
        _G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["PartyMemberFrame"..i.."ManaBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["PartyMemberFrame"..i.."MyHealPredictionBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["PartyMemberFrame"..i.."OtherHealPredictionBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        
        _G["CUI_Party"..i.."AggroBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["CUI_Party"..i.."PetAggroBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["CUI_Party"..i.."PetManaBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    end
    
    CastingBarFrame:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    _G["CleanUIPetCastingBarFrame"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    _G["CleanUICastingBarGlobalCooldownFrame"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    _G["CleanUICastingBarLatency"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    _G["CleanUIPlayerDpsFrameStatusBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    for index=1, MIRRORTIMER_NUMTIMERS do
        _G["MirrorTimer"..index.."StatusBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    end

    -- spell bars
    TargetFrameSpellBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    FocusFrameSpellBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    -- exp bars
    MainMenuExpBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    ReputationWatchStatusBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
    -- party exp bars
    for i=1, 4, 1 do
        _G["CleanUIXpFrame_group"..i.."xpbar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["CleanUIXpFrame_group"..i.."xpbarExhaustion"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    end
    
    -- threat bars
    _G["CleanUIThreatFrame_threatp"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    for i = 1, 10 do
        _G["CleanUIThreatFrame_threat"..i]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["CleanUIThreatFrame_threat"..i.."a"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    end
    
    -- action bar
    _G["CleanUIActionButtonsHealthStatusBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR_VERTICAL);
    _G["CleanUIActionButtonsPowerStatusBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR_VERTICAL);
    
    -- boss frames
    for i=1, 3, 1 do
        _G["Boss"..i.."TargetFrameHealthBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        _G["Boss"..i.."TargetFrameManaBar"]:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    end
    
    for rg = 1, 8 do
        local raidGroup = _G["CompactRaidGroup"..rg]; 	
        
        if (raidGroup) then
            for uu = 1, 5 do
                local unitFrame = _G[raidGroup:GetName().."Member"..uu]; 
            
                unitFrame.healthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
                unitFrame.powerBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
                
                unitFrame.myHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
                unitFrame.otherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
            end
        end
    end

    -- status bar style for warlock shards
    for i=1,SHARD_BAR_NUM_SHARDS do
        local shard = _G["ShardBarFrameShard"..i];  
        shard.shardFill:SetTexture(CleanUIData.CUI_STATUSBAR);            
    end
end

function CleanUI_SetDefaultBackdrop(frame)    
    frame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    frame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
end

function CleanUI_MakeFrameMoveable(frame)  
    frame:SetMovable(true); 
    frame:SetUserPlaced(true); 
    
    frame:HookScript("OnMouseDown", CleanUI_AnyFrameOnMouseDown);
	frame:HookScript("OnMouseUp", CleanUI_AnyFrameOnMouseUp);
end

function CleanUI_AnyFrameOnMouseDown(self, button)
    if (button == "LeftButton") then
        self:StartMoving();
    end
end

function CleanUI_AnyFrameOnMouseUp(self, button)
    self:StopMovingOrSizing();
end

function CleanUI_ReplaceAllBorderTextures(texturename, frame)

    if (CleanUIData.AUTO_CHANGE_BORDER_STYLE ~= 1) then
        return;
    end

    for i, child in ipairs({frame:GetChildren()}) do
    
	    if (child and child:IsObjectType("Frame")) then
	        CleanUI_ReplaceBorderTexture(texturename, child);
	        
	        if (child:IsObjectType("frame")) then	        
	            CleanUI_ReplaceAllBorderTextures(texturename, child);
	        end
	    end
	end
end

function CleanUI_ReplaceBorderTexture(texturename, frame)
    for i, child in ipairs({frame:GetRegions()}) do
	    if (child and child:IsObjectType("texture")) then
	        local texture = child:GetTexture();
	        if (texture) then
                if (string.find(texture, texturename, 1, true)) then
                    child:SetTexture(CleanUIData.CUI_FRAME_BORDER);
                end
	        end
	    end
	end
end

function CleanUI_GC()
    local before = collectgarbage("count");
    collectgarbage();
    local after = collectgarbage("count");
    
    local freed = before - after;
    
    local msg = "collectgarbage:\n"..
        "memory freed: |c00FFFF66"..string.format("%.2f", freed).." kb|r.\n"..
        "current memory use: |c00FFFF66"..string.format("%.2f", after).." kb|r.\n";
        
 	DEFAULT_CHAT_FRAME:AddMessage(msg, 1.0, 1.0, 1.0, 1, 10);
end

function CleanUI_RemoveTextures(frame)
    for i, child in ipairs({frame:GetRegions()}) do
    
        if (child and child:IsObjectType("texture")) then
            child:SetTexture(nil);
        end
    end
end

function CleanUI_ListTextures(frame)
    for i, child in ipairs({frame:GetRegions()}) do
        if (child and child:IsObjectType("texture")) then
            local texture = child:GetTexture();
            if (texture) then
                cui_debug(texture, child:GetName());
            end
        end
    end
    for i, child in ipairs({frame:GetChildren()}) do
        if (child and child:IsObjectType("Frame")) then
            if (not child:IsObjectType("button")) then
            CleanUI_ListTextures(child);
            end
        end
    end
end

function CleanUI_XXXXX(message)

    DEFAULT_CHAT_FRAME:AddMessage("CleanUI FAKE "..(message or "nil"), 1.0, 1.0, 1.0, 1, 10);
end