local MASQUE = LibStub("Masque", true);
local buttongroup = nil;

-- no animations
MainMenuBarVehicleLeaveButton_Update = function (self) CleanUI_MainMenuBarVehicleLeaveButton_Update(); end;

function CleanUI_ActionBarsOnEvent(self, event, ...)
	if (event == "ADDON_LOADED") then
		local addonName = ...;
		if (addonName == "CleanUI") then            
		    if (MASQUE) then
                buttongroup = MASQUE:Group("CleanUI");
            end
        end
    end
    if (event == "UNIT_ENTERED_VEHICLE") then
        local unit = ...;
        if (unit == "player") then
            CleanUI_ShowVehicleMenuBar();
        end
    end
    if (event == "UNIT_EXITED_VEHICLE") then
        local unit = ...;
        if (unit == "player") then
            CleanUI_HideVehicleMenuBar();
        end
    end
    if (event == "UPDATE_BINDINGS") then
        CleanUI_UpdateVehicleBarKeyBindings();
    end
end

function CleanUI_ActionBarsHookEvents()
    if (CleanUIData.CHANGE_ACTIONBARS ~= 1) then 
        return;
    end 
	
	hooksecurefunc("SetupBonusActionBar", CleanUI_SetupBonusActionBar);   
    hooksecurefunc("MultiActionBar_Update", CleanUI_UpdateActionBars);
    hooksecurefunc("ReputationWatchBar_Update", CleanUI_UpdateActionBars);
        
    hooksecurefunc("ActionButton_ShowGrid", CleanUI_ActionButton_ShowGrid);
    hooksecurefunc("ActionButton_HideGrid", CleanUI_ActionButton_HideGrid);
    
    hooksecurefunc("ShowBonusActionBar", CleanUI_ShowBonusActionBar); 
    hooksecurefunc("HideBonusActionBar", CleanUI_HideBonusActionBar);
    
    hooksecurefunc("PetActionBar_UpdatePositionValues", CleanUI_PetActionBar_UpdatePositionValues);
    
    hooksecurefunc(MainMenuExpBar, "Show", CleanUI_MainMenuExpBar_Shown);
    --MainMenuBarMaxLevelBar
end

function CleanUI_ShowVehicleMenuBar() 
    for i = 1, 6 do
        _G["VehicleMenuBarActionButton"..i]:SetAlpha(1);
    end 
end

function CleanUI_HideVehicleMenuBar()
    for i = 1, 6 do
        _G["VehicleMenuBarActionButton"..i]:SetAlpha(0.0);
    end
end


function CleanUI_ShowBonusActionBar(force) 
    for i = 1, 12 do
        _G["ActionButton"..i]:SetAlpha(0.0);
    end
end

function CleanUI_HideBonusActionBar(force)
    for i = 1, 12 do
        _G["ActionButton"..i]:SetAlpha(1.0);
    end
end

function CleanUI_MainMenuBarVehicleLeaveButton_Update()    
    if ( UnitHasVehicleUI("player") ) then
        MainMenuBarVehicleLeaveButton:ClearAllPoints();
        if ( IsPossessBarVisible() ) then
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", PossessButton2, "RIGHT", 30, 0);
        elseif ( GetNumShapeshiftForms() > 0 ) then
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", "ShapeshiftButton"..GetNumShapeshiftForms(), "RIGHT", 30, 0);
        elseif ( HasMultiCastActionBar() ) then
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", MultiCastActionBarFrame, "RIGHT", 30, 0);
        else
            MainMenuBarVehicleLeaveButton:SetPoint("LEFT", PossessBarFrame, "LEFT", 10, 0);
        end
        MainMenuBarVehicleLeaveButton:Show();
        ShowPetActionBar(true);
    else
        MainMenuBarVehicleLeaveButton:Hide();
        ShowPetActionBar(true);
    end
end

function CleanUI_CleanActionBars() 
    
    if (CleanUIData.CHANGE_ACTIONBARS ~= 1) then 
        return;
    end
    
    CleanUIActionButtonsArtFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIActionButtonsArtFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIActionButtonsHealth:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIActionButtonsHealth:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIActionButtonsPower:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIActionButtonsPower:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
        
    local healthBar = CleanUIActionButtonsHealthStatusBar;
    local manaBar = CleanUIActionButtonsPowerStatusBar;
    
	healthBar:SetStatusBarColor(0.0, 1.0, 0.0);
        
    local powerType, powerToken, altR, altG, altB = UnitPowerType("player");
    local info = PowerBarColor[powerToken];
    if ( info ) then
        if ( not manaBar.lockColor ) then
            manaBar:SetStatusBarColor(info.r, info.g, info.b);
        end
    else
        if ( not altR) then
            info = PowerBarColor[powerType] or PowerBarColor["MANA"];
        else
            if ( not manaBar.lockColor ) then
                manaBar:SetStatusBarColor(altR, altG, altB);
            end
        end
    end
    
    for i = 1, 12 do
        local x = (i - 1) * 42;
        _G["ActionButton"..i]:ClearAllPoints();
        _G["ActionButton"..i]:SetPoint("BOTTOMLEFT", CleanUIActionButtonsArtFrame, "BOTTOMLEFT", 7 + x, 7);
        
        _G["BonusActionButton"..i]:ClearAllPoints();
        _G["BonusActionButton"..i]:SetPoint("BOTTOMLEFT", CleanUIActionButtonsArtFrame, "BOTTOMLEFT", 7 + x, 7);
        
        _G["MultiBarBottomLeftButton"..i]:ClearAllPoints();
        _G["MultiBarBottomLeftButton"..i]:SetPoint("TOPLEFT", CleanUIActionButtonsArtFrame, "TOPLEFT", 7 + x, -7);
    end
    
    for i = 1, 6 do
        local x = (i - 1) * 42;
        _G["MultiBarBottomRightButton"..i]:ClearAllPoints();
        _G["MultiBarBottomRightButton"..i]:SetPoint("TOPLEFT", CleanUIActionButtonsArtFrame, "TOPLEFT", 511 + x, -7);
        
        _G["MultiBarBottomRightButton"..(i+6)]:ClearAllPoints();
        _G["MultiBarBottomRightButton"..(i+6)]:SetPoint("BOTTOMLEFT", CleanUIActionButtonsArtFrame, "BOTTOMLEFT", 511 + x, 7);
    end
    
    local barType = GetBonusBarOverrideBarType() or "default";
    local barInfo = BonusActionBarGetBarInfo(barType);
    barInfo.buttonX = 4;
    barInfo.buttonY = 6;

    -- hide reputation bar
    SetWatchedFactionIndex(0);
    
    CleanUI_UpdateActionBars();		
    CleanUI_CleanVehicleBar();
    CleanUI_ChangeActionBarUpDownButtons();
    
    CleanUI_CleanManagedFramePositions();
            
    cui_actionbars_loaded = true;
    
end

function CleanUI_CleanManagedFramePositions()
	for index, id in pairs(UIPARENT_MANAGED_FRAME_POSITIONS) do
        UIPARENT_MANAGED_FRAME_POSITIONS[index].reputation = 0;
        UIPARENT_MANAGED_FRAME_POSITIONS[index].maxLevel = 0;
	end
	
	UIParent_ManageFramePositions();
end

function CleanUI_CleanVehicleBar()
    
    CleanUI_HideVehicleMenuBar();
    
    -- hide reputation bar
    SetWatchedFactionIndex(0);
            
    -- no events
    MainMenuBarArtFrame:UnregisterEvent("UNIT_ENTERING_VEHICLE");
    MainMenuBarArtFrame:UnregisterEvent("UNIT_ENTERED_VEHICLE");
    MainMenuBarArtFrame:UnregisterEvent("UNIT_EXITING_VEHICLE");
    MainMenuBarArtFrame:UnregisterEvent("UNIT_EXITED_VEHICLE");
    MainMenuBarArtFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
    
    UIPARENT_MANAGED_FRAME_POSITIONS["MainMenuBar"] = nil;
    
    UIPARENT_MANAGED_FRAME_POSITIONS["ShapeshiftBarFrame"] = nil;
    UIPARENT_MANAGED_FRAME_POSITIONS["MultiCastActionBarFrame"] = nil;
    UIPARENT_MANAGED_FRAME_POSITIONS["PossessBarFrame"] = nil;
    
    UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarRight"] = nil;
    UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil;
    UIPARENT_MANAGED_FRAME_POSITIONS["PETACTIONBAR_YPOS"] = nil;

    --hack, to make sure the seat indicator is placed in the right spot
    if not _G['VehicleSeatIndicator']:IsUserPlaced() then
        _G['VehicleSeatIndicator']:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOMRIGHT", 0, -13);
    end
    
    -- setup button skins
    VehicleMenuBarPitchUpButton:SetWidth(30);
    VehicleMenuBarPitchUpButton:SetHeight(30);
    VehicleMenuBarPitchUpButton:GetNormalTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-Pitch-Up");
    VehicleMenuBarPitchUpButton:GetNormalTexture():SetTexCoord(0.21875, 0.765625, 0.234375, 0.78125);
    VehicleMenuBarPitchUpButton:GetPushedTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-Pitch-Down");
    VehicleMenuBarPitchUpButton:GetPushedTexture():SetTexCoord(0.21875, 0.765625, 0.234375, 0.78125);

    VehicleMenuBarPitchDownButton:SetWidth(30);
    VehicleMenuBarPitchDownButton:SetHeight(30);
    VehicleMenuBarPitchDownButton:GetNormalTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-PitchDown-Up");
    VehicleMenuBarPitchDownButton:GetNormalTexture():SetTexCoord(0.21875, 0.765625, 0.234375, 0.78125);
    VehicleMenuBarPitchDownButton:GetPushedTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-PitchDown-Down");
    VehicleMenuBarPitchDownButton:GetPushedTexture():SetTexCoord(0.21875, 0.765625, 0.234375, 0.78125);

    VehicleMenuBarLeaveButton:SetWidth(30);
    VehicleMenuBarLeaveButton:SetHeight(30);
    VehicleMenuBarLeaveButton:GetNormalTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Up");
    VehicleMenuBarLeaveButton:GetNormalTexture():SetTexCoord(0.140625, 0.859375, 0.140625, 0.859375);
    VehicleMenuBarLeaveButton:GetPushedTexture():SetTexture("Interface\\Vehicles\\UI-Vehicles-Button-Exit-Down");
    VehicleMenuBarLeaveButton:GetPushedTexture():SetTexCoord(0.140625, 0.859375, 0.140625, 0.859375);
    
    VehicleMenuBarArtFrame:Hide();
    VehicleMenuBarPitchSlider:Hide();
    
    VehicleMenuBarActionButtonFrame:ClearAllPoints(); 
    VehicleMenuBarActionButtonFrame:SetPoint("BOTTOMLEFT", MainMenuBar, "BOTTOMLEFT", 8, 4);
end

function CleanUI_CleanVehicleButtons()        
        
    -- Rahmen
    CleanUIVehicleButtonFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIVehicleButtonFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIVehicleButtonFrame:SetFrameStrata("BACKGROUND");        
    
    CleanUIVehicleButtonFrame:SetClampedToScreen(true);
    CleanUIVehicleButtonFrame:SetClampRectInsets(1, -1, -1, 1);
    
    local offset = 6;
    
    for i = 1, 6 do
        local name = "VehicleMenuBarActionButton"..i;   
        local button = _G[name];
        button:SetWidth(36);
        button:SetHeight(36);
        
        button:SetParent(CleanUIVehicleButtonFrame);
        button:Show();
        button:SetFrameStrata("LOW");
        
        CleanUI_UpdateVehicleBarKeyBindings();
    end
    
    CleanUI_ChangeVehicleButtonBarLayout();
    CleanUI_VehicleMenuBar_UpdateActionBars();
end

function CleanUI_UpdateVehicleBarKeyBindings()    
	for i = 1, 6 do	
	    local name = "VehicleMenuBarActionButton"..i;	
	    local button = _G[name];
        local key1, key2 = GetBindingKey("CLICK VehicleMenuBarActionButton"..i..":LeftButton");
        
		local orighotkey = _G[name.."HotKey"];
		orighotkey:Hide();
		
        local hotkey = _G["CUI_"..name.."hotkey"..i];
        if (not hotkey) then
            hotkey = button:CreateFontString("CUI_"..name.."hotkey"..i, "ARTWORK");
        end    
            
		hotkey:SetFontObject("NumberFontNormalSmallGray");
		hotkey:SetJustifyH("RIGHT");
		hotkey:SetWidth(36);
		hotkey:SetHeight(10);
		
	    hotkey:SetPoint("TOPRIGHT", -2, -2);
		
		if (key1) then
            local text = GetBindingText(key1, "KEY_", 1);
            hotkey:SetText(text);
        else
            --hotkey:SetText(RANGE_INDICATOR);
            hotkey:SetText("");
        end
	
		hotkey:Show();
	end
end

function CleanUI_VehicleMenuBar_UpdateActionBars()
    CleanUI_ChangeVehicleButtonBarLayout();
end

function CleanUI_ChangeVehicleButtonBarLayout()

    if (CleanUIData.VEHICLEBAR_STYLE == 1) then
        -- 1 Zeile
        CleanUIVehicleButtonFrame:SetWidth(261);
        CleanUIVehicleButtonFrame:SetHeight(50);
        
        VehicleMenuBarActionButton1:ClearAllPoints(); 
        VehicleMenuBarActionButton1:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -7);
        VehicleMenuBarActionButton2:ClearAllPoints(); 
        VehicleMenuBarActionButton2:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 49, -7);
        VehicleMenuBarActionButton3:ClearAllPoints(); 
        VehicleMenuBarActionButton3:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 91, -7);
        VehicleMenuBarActionButton4:ClearAllPoints(); 
        VehicleMenuBarActionButton4:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 133, -7);
        VehicleMenuBarActionButton5:ClearAllPoints(); 
        VehicleMenuBarActionButton5:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 175, -7);
        VehicleMenuBarActionButton6:ClearAllPoints(); 
        VehicleMenuBarActionButton6:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 217, -7);
    elseif (CleanUIData.VEHICLEBAR_STYLE == 2) then
        -- 2 Zeilen
        CleanUIVehicleButtonFrame:SetWidth(134);
        CleanUIVehicleButtonFrame:SetHeight(96);
        
        VehicleMenuBarActionButton1:ClearAllPoints(); 
        VehicleMenuBarActionButton1:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -7);
        VehicleMenuBarActionButton2:ClearAllPoints(); 
        VehicleMenuBarActionButton2:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 49, -7);
        VehicleMenuBarActionButton3:ClearAllPoints(); 
        VehicleMenuBarActionButton3:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 91, -7);
        VehicleMenuBarActionButton4:ClearAllPoints(); 
        VehicleMenuBarActionButton4:SetPoint("BOTTOMLEFT", CleanUIVehicleButtonFrame, "BOTTOMLEFT", 7, 7);
        VehicleMenuBarActionButton5:ClearAllPoints(); 
        VehicleMenuBarActionButton5:SetPoint("BOTTOMLEFT", CleanUIVehicleButtonFrame, "BOTTOMLEFT", 49, 7);
        VehicleMenuBarActionButton6:ClearAllPoints(); 
        VehicleMenuBarActionButton6:SetPoint("BOTTOMLEFT", CleanUIVehicleButtonFrame, "BOTTOMLEFT", 91, 7);
    elseif (CleanUIData.VEHICLEBAR_STYLE == 3) then
        -- 1 Spalte
        CleanUIVehicleButtonFrame:SetWidth(50);
        CleanUIVehicleButtonFrame:SetHeight(261);
        
        VehicleMenuBarActionButton1:ClearAllPoints(); 
        VehicleMenuBarActionButton1:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -7);
        VehicleMenuBarActionButton2:ClearAllPoints(); 
        VehicleMenuBarActionButton2:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -49);
        VehicleMenuBarActionButton3:ClearAllPoints(); 
        VehicleMenuBarActionButton3:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -91);
        VehicleMenuBarActionButton4:ClearAllPoints(); 
        VehicleMenuBarActionButton4:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -133);
        VehicleMenuBarActionButton5:ClearAllPoints(); 
        VehicleMenuBarActionButton5:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -175);
        VehicleMenuBarActionButton6:ClearAllPoints(); 
        VehicleMenuBarActionButton6:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -217);
    elseif (CleanUIData.VEHICLEBAR_STYLE == 4) then
        -- 2 Spalten
        CleanUIVehicleButtonFrame:SetWidth(96);
        CleanUIVehicleButtonFrame:SetHeight(134);
        
        VehicleMenuBarActionButton1:ClearAllPoints(); 
        VehicleMenuBarActionButton1:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -7);
        VehicleMenuBarActionButton2:ClearAllPoints(); 
        VehicleMenuBarActionButton2:SetPoint("TOPRIGHT", CleanUIVehicleButtonFrame, "TOPRIGHT", -7, -7);
        VehicleMenuBarActionButton3:ClearAllPoints(); 
        VehicleMenuBarActionButton3:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -49);
        VehicleMenuBarActionButton4:ClearAllPoints(); 
        VehicleMenuBarActionButton4:SetPoint("TOPRIGHT", CleanUIVehicleButtonFrame, "TOPRIGHT", -7, -49);
        VehicleMenuBarActionButton5:ClearAllPoints(); 
        VehicleMenuBarActionButton5:SetPoint("TOPLEFT", CleanUIVehicleButtonFrame, "TOPLEFT", 7, -91);
        VehicleMenuBarActionButton6:ClearAllPoints(); 
        VehicleMenuBarActionButton6:SetPoint("TOPRIGHT", CleanUIVehicleButtonFrame, "TOPRIGHT", -7, -91);
    end

    -- oversized buttons??
    if (MASQUE and buttongroup) then
        for i = 1, 6 do
            buttongroup:RemoveButton(_G["VehicleMenuBarActionButton"..i]);
            buttongroup:AddButton(_G["VehicleMenuBarActionButton"..i]);
        end 
    end 
end

function CleanUI_MainMenuExpBar_Shown() 
    if (CleanUIData.SHOW_ORIG_XPBAR ~= 1) then
        MainMenuExpBar:Hide();
    end
    
    CleanUI_MainMenuExpBar_HackBarYPositions();
end

function CleanUI_MainMenuExpBar_HackBarYPositions()
    MainMenuBar:SetHeight(53);
    
    local level = UnitLevel("player");
    
    if (level < MAX_PLAYER_LEVEL and CleanUIData.SHOW_ORIG_XPBAR ~= 1) then
        MainMenuBar:SetHeight(48);
    end
end

function CleanUI_UpdateActionBars(newLevel) 	
	if (not newLevel) then
		newLevel = UnitLevel("player");
	end
	
    local y = -105;
    local offset = 105 + y;
	
    if (CleanUIData.CHANGE_ACTIONBARS == 1) then 	
        
        local xpBarShown = newLevel < MAX_PLAYER_LEVEL;
    
        if (CleanUIData.SHOW_ORIG_XPBAR ~= 1) then
            xpBarShown = false;
            MainMenuExpBar:Hide();
        else
            MainMenuExpBar:Show();
        end
        CleanUI_MainMenuExpBar_HackBarYPositions();
            
        CleanUI_RescaleActionButtonFrame();
        ReputationWatchStatusBar:SetHeight(3);
        
        -- noch nicht auf max. Level
        if (xpBarShown) then
            y = -100;
            
            ReputationWatchStatusBar:SetHeight(4);
            ReputationWatchBar:ClearAllPoints();
            ReputationWatchBar:SetPoint("TOP", MainMenuExpBar, "BOTTOM", 0, 0);
            ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, "CENTER", 0, 3);
        else        
            y = -105; 
            ReputationWatchBar:ClearAllPoints();
            ReputationWatchBar:SetPoint("TOP", MainMenuBar, "BOTTOM", 0, 49);
            ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, "CENTER", 0, 3);
        end
        
        -- Offset, wenn die Aktionsleisten nicht sichtbar sind
        if (not SHOW_MULTI_ACTIONBAR_1 and not SHOW_MULTI_ACTIONBAR_2) then
            y = y - 40;
        end
        
        offset = 105 + y;
        
        if (CleanUIData.CHANGE_ACTIONBARS == 1) then 
            CleanUI_CleanActionButtons();
            CleanUI_CleanVehicleButtons();
            CleanUI_PlayerMenuBar();  
        end
    
        CleanUIActionButtonsArtFrame:SetHeight(96 + offset);  
        CleanUIActionButtonsArtFrame:Show();
    else 
        CleanUIActionButtonsArtFrame:Hide();
    end

    if (CleanUIData.ACTIONBARS_SHOWSTATUS == 1) then 
        CleanUIActionButtonsHealth:Show();
        CleanUIActionButtonsPower:Show();
        
        if (CleanUIData.ACTIONBARS_STATUSPOSITION == 1) then
            CleanUIActionButtonsHealth:ClearAllPoints();
            CleanUIActionButtonsHealth:SetPoint("TOPLEFT", CleanUIActionButtonsArtFrame, "TOPRIGHT", -2, 0);  
        
            CleanUIActionButtonsPower:ClearAllPoints();         
            CleanUIActionButtonsPower:SetPoint("TOPRIGHT", CleanUIActionButtonsArtFrame, "TOPLEFT", 2, 0); 
        else
            CleanUIActionButtonsHealth:ClearAllPoints();
            CleanUIActionButtonsHealth:SetPoint("TOPRIGHT", CleanUIActionButtonsArtFrame, "TOPLEFT", 2, 0); 
        
            CleanUIActionButtonsPower:ClearAllPoints();         
            CleanUIActionButtonsPower:SetPoint("TOPLEFT", CleanUIActionButtonsArtFrame, "TOPRIGHT", -2, 0);  
        end
        
        CleanUIActionButtonsHealth:SetWidth(CleanUIData.ACTIONBARS_STATUSWIDTH or 60); 
        CleanUIActionButtonsHealth:SetHeight(96 + offset);  
        
        CleanUIActionButtonsHealthStatusBar:ClearAllPoints(); 
        CleanUIActionButtonsHealthStatusBar:SetPoint("TOPLEFT", CleanUIActionButtonsHealth, "TOPLEFT", 5, -5);
        CleanUIActionButtonsHealthStatusBar:SetPoint("BOTTOMRIGHT", CleanUIActionButtonsHealth, "BOTTOMRIGHT", -5, 5);
        
        CleanUIActionButtonsPower:SetWidth(CleanUIData.ACTIONBARS_STATUSWIDTH or 60); 
        CleanUIActionButtonsPower:SetHeight(96 + offset);
        
        CleanUIActionButtonsPowerStatusBar:ClearAllPoints(); 
        CleanUIActionButtonsPowerStatusBar:SetPoint("TOPLEFT", CleanUIActionButtonsPower, "TOPLEFT", 5, -5);
        CleanUIActionButtonsPowerStatusBar:SetPoint("BOTTOMRIGHT", CleanUIActionButtonsPower, "BOTTOMRIGHT", -5, 5);
        
        if (CleanUIData.ACTIONBARS_SHOWSTATUSTEXT == 1) then
            CleanUIActionButtonsHealthStatusBarText:Show();
            CleanUIActionButtonsPowerStatusBarText:Show();
        else
            CleanUIActionButtonsHealthStatusBarText:Hide();
            CleanUIActionButtonsPowerStatusBarText:Hide();
        end
    else 
        CleanUIActionButtonsHealth:Hide();
        CleanUIActionButtonsPower:Hide();
    end
end

function CleanUI_ActionButton_ShowGrid(button)
	if (not button) then
	    return;
	end
	
	if ( button:GetAttribute("showgrid") > 1) then
		button:SetAttribute("showgrid", 1);
	end

	if ( button:GetAttribute("showgrid") >= 1 and not button:GetAttribute("statehidden") ) then
		button:Show();
	end
end

function CleanUI_ActionButton_HideGrid(button)
	if (not button) then
	    return;
	end
	
	if ( button:GetAttribute("showgrid") < 0) then
		button:SetAttribute("showgrid", 0);
	end
	
	if ( button:GetAttribute("showgrid") == 0 and not HasAction(button.action) ) then
		button:Hide();
	end
end

function CleanUI_CleanActionButtons()

    if (CleanUIData.CHANGE_ACTIONBARS ~= 1) then 
        return;
    end
    
    for i = 1, 12 do
        _G["MultiBarBottomLeftButton"..i.."FloatingBG"]:SetTexture(nil);
        _G["MultiBarBottomRightButton"..i.."FloatingBG"]:SetTexture(nil);
        _G["MultiBarRightButton"..i.."FloatingBG"]:SetTexture(nil);
        _G["MultiBarLeftButton"..i.."FloatingBG"]:SetTexture(nil);
    end
    
    if (CleanUIData.ACTIONBARS_SHOWMACRONAMES == 0) then 
        for i = 1, 12 do
            _G["ActionButton"..i.."Name"]:Hide();
            _G["BonusActionButton"..i.."Name"]:Hide();
            _G["MultiBarBottomLeftButton"..i.."Name"]:Hide();
            _G["MultiBarBottomRightButton"..i.."Name"]:Hide();
            _G["MultiBarRightButton"..i.."Name"]:Hide();
            _G["MultiBarLeftButton"..i.."Name"]:Hide();
        end
        
        for i = 1, 10 do
            _G["ShapeshiftButton"..i.."Name"]:Hide();
        end	
    end    
		
    if (MASQUE and buttongroup) then
        if (CleanUIData.BUTTONFACADE_ACTIONBUTTONS == 1) then
            CleanUI_SkinActionBars(); 
        end
    end
end

function CleanUI_SkinActionBars()
    for i = 1, 12 do
        buttongroup:AddButton(_G["ActionButton"..i]);
        buttongroup:AddButton(_G["BonusActionButton"..i]);
        buttongroup:AddButton(_G["MultiBarBottomLeftButton"..i]);
        buttongroup:AddButton(_G["MultiBarBottomRightButton"..i]);
        buttongroup:AddButton(_G["MultiBarRightButton"..i]);
        buttongroup:AddButton(_G["MultiBarLeftButton"..i]);
    end

    for i = 1, 10 do
        buttongroup:AddButton(_G["ShapeshiftButton"..i]);
        buttongroup:AddButton(_G["PetActionButton"..i]);
    end	

    for i = 1, 6 do
        buttongroup:AddButton(_G["VehicleMenuBarActionButton"..i]);
    end	
end

function CleanUI_PlayerMenuBar()

    if (CleanUIData.CHANGE_ACTIONBARS ~= 1) then 
        return;
    end
    
    CleanUI_RemoveArtwork();
    CleanUI_RescaleExpBar();
end

function CleanUI_SetupBonusActionBar()	

    if (CleanUIData.CHANGE_ACTIONBARS ~= 1) then 
        return;
    end
    
	BonusActionBarFrameTexture1:SetTexture();
	BonusActionBarFrameTexture2:SetTexture();
	BonusActionBarFrameTexture3:SetTexture();
	BonusActionBarFrameTexture1:Hide();
	BonusActionBarFrameTexture2:Hide();
	BonusActionBarFrameTexture3:Hide();
end

function CleanUI_RemoveArtwork()
	MainMenuBarLeftEndCap:SetTexture();
	MainMenuBarRightEndCap:SetTexture();
	MainMenuBarLeftEndCap:Hide();
	MainMenuBarRightEndCap:Hide();
	
	MainMenuMaxLevelBar0:SetTexture();
	MainMenuMaxLevelBar1:SetTexture();
	MainMenuMaxLevelBar2:SetTexture();
	MainMenuMaxLevelBar3:SetTexture();
	MainMenuMaxLevelBar0:Hide();
	MainMenuMaxLevelBar1:Hide();
	MainMenuMaxLevelBar2:Hide();
	MainMenuMaxLevelBar3:Hide();
	
	BonusActionBarFrameTexture1:SetTexture();
	BonusActionBarFrameTexture2:SetTexture();
	BonusActionBarFrameTexture3:SetTexture();
	BonusActionBarFrameTexture1:Hide();
	BonusActionBarFrameTexture2:Hide();
	BonusActionBarFrameTexture3:Hide();
	
	MainMenuBarTexture0:SetTexture();
	MainMenuBarTexture1:SetTexture();
	MainMenuBarTexture2:SetTexture();
	MainMenuBarTexture3:SetTexture();
	MainMenuBarTexture0:Hide();
	MainMenuBarTexture1:Hide();
	MainMenuBarTexture2:Hide();
	MainMenuBarTexture3:Hide();
	
	MainMenuXPBarTextureLeftCap:SetTexture();
	MainMenuXPBarTextureRightCap:SetTexture();
	MainMenuXPBarTextureMid:SetTexture();
	MainMenuXPBarTextureLeftCap:Hide();
	MainMenuXPBarTextureRightCap:Hide();
	MainMenuXPBarTextureMid:Hide();
	
	for i=1,19 do
		local texture = _G["MainMenuXPBarDiv"..i];
		texture:SetTexture();
		texture:Hide();
	end
	
	PossessBackground1:SetTexture();
	PossessBackground2:SetTexture();
	PossessBackground1:Hide();
	PossessBackground2:Hide();
	
	SlidingActionBarTexture0:SetTexture();
	SlidingActionBarTexture1:SetTexture();
	SlidingActionBarTexture0:Hide();
	SlidingActionBarTexture1:Hide();
	
	ShapeshiftBarLeft:SetTexture();
	ShapeshiftBarRight:SetTexture();
	ShapeshiftBarMiddle:SetTexture();
	ShapeshiftBarLeft:Hide();
	ShapeshiftBarRight:Hide();
	ShapeshiftBarMiddle:Hide();
	
	ReputationWatchBarTexture0:SetTexture();
	ReputationWatchBarTexture1:SetTexture();
	ReputationWatchBarTexture2:SetTexture();
	ReputationWatchBarTexture3:SetTexture();
	ReputationWatchBarTexture0:Hide();
	ReputationWatchBarTexture1:Hide();
	ReputationWatchBarTexture2:Hide();
	ReputationWatchBarTexture3:Hide();
	
	ReputationXPBarTexture0:SetTexture();
	ReputationXPBarTexture1:SetTexture();
	ReputationXPBarTexture2:SetTexture();
	ReputationXPBarTexture3:SetTexture();
	ReputationXPBarTexture0:Hide();
	ReputationXPBarTexture1:Hide();
	ReputationXPBarTexture2:Hide();
	ReputationXPBarTexture3:Hide();
	
	MainMenuBarPageNumber:Hide();
end

function CleanUI_VehicleButtonFrame_OnMouseDown(frame, button)
    if (button == "RightButton") then
        if (IsControlKeyDown()) then
            frame:StartMoving();
        end
    end
end

function CleanUI_VehicleButtonFrame_OnMouseUp(frame, button)
    if (button == "RightButton") then
        frame:StopMovingOrSizing();
    end
end 

function CleanUI_RescaleActionButtonFrame()

    local width = 764;
    
    -- Rechte Aktionsleiste ist weg (1 bedeutet, die Leiste ist ber die Pfeilbuttonserreichbar)
    if (VIEWABLE_ACTION_BAR_PAGES[BOTTOMRIGHT_ACTIONBAR_PAGE]) then
        width = 512;
    end
    
    -- Rucksack wird angezeigt
    if (CleanUIData.BAGS_MOVEBAGBUTTONS ~= 1) then
        width = width + 102;
    end
    
    -- Rucksack ist weg
    if (CleanUIData.BAGS_SHOWBACKBACKBUTTON == 1) then
        width = width + 51;
    end

    MainMenuBar:SetWidth(width);
    CleanUIActionButtonsArtFrame:SetWidth(width);
	MainMenuExpBar:SetWidth(width - 12);
    ReputationWatchStatusBar:SetWidth(width - 12);
    
    CleanUI_PetActionBar_UpdatePositionValues();
	PetActionBarFrame:SetPoint("TOPLEFT", MainMenuBar, "BOTTOMLEFT", PETACTIONBAR_XPOS, PETACTIONBAR_YPOS);
end

function CleanUI_RescaleExpBar()
    CleanUI_RescaleActionButtonFrame();
	MainMenuExpBar:SetHeight(6);
	ExhaustionLevelFillBar:SetHeight(6);
	
	ExhaustionTick:SetNormalTexture("Interface\\AddOns\\CleanUI\\skins\\ExhaustionTick");
	ExhaustionTick:SetHighlightTexture("Interface\\AddOns\\CleanUI\\skins\\ExhaustionTickHighlight");
end

function CleanUI_ChangeActionBarUpDownButtons()  

    -- verstecken, bis ich einen besseren PLatz finde...
    ActionBarUpButton:Hide();
    ActionBarDownButton:Hide();

    ActionBarUpButton:SetWidth(16);
    ActionBarDownButton:SetWidth(16);

    ActionBarUpButton:ClearAllPoints();
    ActionBarUpButton:SetPoint("LEFT", CleanUIActionButtonsArtFrame, "LEFT", 502, -14);
    ActionBarDownButton:ClearAllPoints();
    ActionBarDownButton:SetPoint("LEFT", CleanUIActionButtonsArtFrame, "LEFT", 502, -30);
        
	ActionBarUpButton:SetNormalTexture("Interface\\AddOns\\CleanUI\\skins\\uparrow");
	ActionBarUpButton:SetPushedTexture("Interface\\AddOns\\CleanUI\\skins\\uparrow");
	ActionBarUpButton:SetHighlightTexture("Interface\\AddOns\\CleanUI\\skins\\uparrow_highlight");
	ActionBarUpButton:SetDisabledTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	
	ActionBarDownButton:SetNormalTexture("Interface\\AddOns\\CleanUI\\skins\\downarrow");
	ActionBarDownButton:SetPushedTexture("Interface\\AddOns\\CleanUI\\skins\\downarrow");
	ActionBarDownButton:SetHighlightTexture("Interface\\AddOns\\CleanUI\\skins\\downarrow_highlight");
	ActionBarDownButton:SetDisabledTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
end

function CleanUI_PetActionBar_UpdatePositionValues()	
	if (PETACTIONBAR_XPOS == 500) then
	    PETACTIONBAR_XPOS = MainMenuBar:GetWidth() - 450;    
	end
end