local oldname = nil;

function CleanUI_EquipmentSetsHookEvents()
	hooksecurefunc("UnitPopup_ShowMenu", CleanUI_UnitPopup_ShowMenu);   
end

function CleanUI_UnitPopup_ShowMenu(dropdownMenu, which, unit, name, userData)

    if (unit ~= "player" or UIDROPDOWNMENU_MENU_LEVEL > 1) then
	    return;
	end
    
    if (GetNumEquipmentSets() > 0) then
        local eq_header = UIDropDownMenu_CreateInfo();
        eq_header.text = "EquipmentSets";
        eq_header.isNotRadio = true;
        eq_header.notCheckable = 1;
        eq_header.isTitle = true;    
        UIDropDownMenu_AddButton(eq_header);
        
        CleanUI_DetectEqippedSet();
        
        for ii=1, GetNumEquipmentSets() do
            local name = GetEquipmentSetInfo(ii);
            
            local info = UIDropDownMenu_CreateInfo();
            info.text = name;
            info.func = function(frame) CleanUI_SelectEquipmentSet(name) end;
            
            if (CleanUIData.EQUIPPED_SETNAME == name) then
                info.checked = true;
            end
            
            UIDropDownMenu_AddButton(info);
        end
	end
end

function CleanUI_DetectEqippedSet()
    local array = {};

    for ii=1, GetNumEquipmentSets() do
        local name = GetEquipmentSetInfo(ii);
    
        array = GetEquipmentSetLocations(name, array);

        local checksum = 0;
        
        for index=1, 19 do                
            local player, bank, bags, slot, bag = EquipmentManager_UnpackLocation(array[index]);
            
            if (player and not (bank or bags or bag)) then
                --DEFAULT_CHAT_FRAME:AddMessage("equipped", 1.0, 1.0, 1.0, 1, 10);  
            else 
                if (slot > 1) then
                    checksum = checksum - 1;
                end
            end
        end
        
        if (checksum == 0) then
            CleanUIData.EQUIPPED_SETNAME = name;
            return;
        end
    end
    
    CleanUIData.EQUIPPED_SETNAME = nil;
end

function CleanUI_SelectEquipmentSet(name)
    UseEquipmentSet(name);
    PlaySound("igInventoryOepn");
 	DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI:|r equipment set "..name.." loaded.", 1.0, 1.0, 1.0, 1, 10);
end