function CleanUI_GuildOnEvent(self, event, ...)
	if (event == "ADDON_LOADED") then
		local addonName = ...;
        if ( addonName == "Blizzard_GuildUI" ) then
		    CleanUI_StartDelay(2, CleanUI_InitGuildRoster);
        end
    end
end

function CleanUI_GuildHookEvents()
end

function CleanUI_GuildOnUpdate(self, elapsed)
end

function CleanUI_GuildRosterFrame_OnShow(self)
    CleanUI_InitGuildRoster();
end

function CleanUI_InitGuildRoster()
    local button;

    for ii = 1, 14 do
        button = _G["GuildRosterContainerButton"..ii];
        button:SetScript("OnEnter", function() CleanUI_GuildRosterShowTooltip(ii); end);
    end
end

function CleanUI_GuildRosterShowTooltip(index)
    button = _G["GuildRosterContainerButton"..index];
 	
	local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(button.guildIndex);
 	
    --GameTooltip_SetDefaultAnchor(GameTooltip, button);	
	GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
    
	local classColor = RAID_CLASS_COLORS[classFileName];
	local classColorText = string.format("ff%.2x%.2x%.2x", classColor.r * 255, classColor.g * 255, classColor.b * 255);

    GameTooltip:SetText("|c"..classColorText..name.."|r ("..level..")");    
    GameTooltip:AddLine("|cffffffff"..rank.."|r");        
    if (online) then
        GameTooltip:AddLine(BN_TOAST_ONLINE);
    else
        GameTooltip:AddLine(BN_TOAST_OFFLINE);
        GameTooltip:AddLine("|cffffffff"..string.format(BNET_LAST_ONLINE_TIME, RecentTimeDate(GetGuildRosterLastOnline(button.guildIndex))).."|r");  
    end
    GameTooltip:AddLine(" "); 
    
    GameTooltip:AddLine("|cffffffff"..ZONE..":|r "..zone);   
    GameTooltip:AddLine(" "); 
    
    GameTooltip:AddLine(note);       
    if (note) then
        GameTooltip:AddLine(officernote);
    end
    GameTooltip:AddLine(" "); 
    
    GameTooltip:AddLine(ACHIEVEMENTS..":");     
    GameTooltip:AddLine("|cffffffff"..ACHIEVEMENT_POINTS..":|r "..achievementPoints);  
    GameTooltip:AddLine("|cffffffff"..RANK..":|r "..achievementRank);  
		
    GameTooltip:Show();
end

function CleanUI_GuildRosterHideTooltip()
	GameTooltip:Hide();
end