function CleanUI_MailOnEvent(self, event, ...)
end

function CleanUI_MailHookEvents()
	hooksecurefunc("SendMailFrame_Update", CleanUI_SendMailFrame_Update);
	hooksecurefunc("OpenMailFrame_UpdateButtonPositions", CleanUI_OpenMailFrame_UpdateButtonPositions);
end

function CleanUI_SendMailFrame_Update()
	for i=1, ATTACHMENTS_MAX_SEND do
		local itemLink = GetSendMailItemLink(i);
		
		local button = _G["SendMailAttachment"..i];
		local icon = _G[button:GetName().."Icon"];
		
		if (not icon) then
            icon = button:CreateTexture(button:GetName().."Icon", "BORDER");
        end
        
        icon:ClearAllPoints();
        icon:SetPoint("TOPLEFT", -2, 2);
        icon:SetPoint("BOTTOMRIGHT", 2, -2);
        
		local border = button:GetNormalTexture();
	
        if (border) then
            border:ClearAllPoints();
            border:SetPoint("TOPLEFT", -16, 16);
            border:SetPoint("BOTTOMRIGHT", 16, -16);
        end
    
		local itemName, itemTexture, stackCount, quality = GetSendMailItem(i);
		
		icon:SetTexture(itemTexture);
	    CleanUI_SetItemButtonBorderColor(itemLink, button);
	end
end

function CleanUI_OpenMailFrame_UpdateButtonPositions(letterIsTakeable, textCreated, stationeryIcon, money)
	-- items
	for i=1, ATTACHMENTS_MAX_RECEIVE do
		local name, itemTexture, count, quality, canUse = GetInboxItem(InboxFrame.openMailID, i);
		local itemLink = GetInboxItemLink(InboxFrame.openMailID, i);
		
		local attachmentButton = _G["OpenMailAttachmentButton"..i];
	    CleanUI_SetItemButtonBorderColor(itemLink, attachmentButton);
    end
end