local durability = "";
local itemlevel = "";
local money = "";

local inv_slots = {
	(GetInventorySlotInfo("HeadSlot")),
	(GetInventorySlotInfo("NeckSlot")),
	(GetInventorySlotInfo("ShoulderSlot")),
	(GetInventorySlotInfo("BackSlot")),
	(GetInventorySlotInfo("ChestSlot")),
	(GetInventorySlotInfo("WristSlot")),
	(GetInventorySlotInfo("HandsSlot")),
	(GetInventorySlotInfo("WaistSlot")),
	(GetInventorySlotInfo("LegsSlot")),
	(GetInventorySlotInfo("FeetSlot")),
	(GetInventorySlotInfo("Finger0Slot")),
	(GetInventorySlotInfo("Finger1Slot")),
	(GetInventorySlotInfo("Trinket0Slot")),
	(GetInventorySlotInfo("Trinket1Slot")),
	(GetInventorySlotInfo("MainHandSlot")),
	(GetInventorySlotInfo("SecondaryHandSlot")),
	(GetInventorySlotInfo("RangedSlot")),
}

local mouseover = 0;
	
local microbutton_names = {
    "CharacterMicroButton",
    "SpellbookMicroButton",
    "TalentMicroButton",
    "AchievementMicroButton",
    "QuestLogMicroButton",
    "GuildMicroButton",
    "PVPMicroButton",
    "LFDMicroButton",
    "EJMicroButton",
    "RaidMicroButton",
    "MainMenuMicroButton",
    "HelpMicroButton",
}

function CleanUI_MinimapOnEvent(self, event, ...)
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then        
        return;
    end
    
    if (event == "UPDATE_PENDING_MAIL" or event == "MAIL_CLOSED") then
        if ( HasNewMail() ) then
            CleanUI_ShowMinimapButtons();
        else
            CleanUI_HideMinimapButtons();
        end
	end
 	
	if (event == "PLAYER_ENTERING_WORLD") then
	    money = CleanUI_GetPlayerMoney();
	    durability = CleanUI_GetPlayerDurability();
	    itemlevel = CleanUI_GetPlayerItemLevel();
 	end
 	
    if (event == "PLAYER_MONEY") then
	    money = CleanUI_GetPlayerMoney();
	end
 	
	if (event == "PLAYER_DEAD" or 
	    event == "UPDATE_INVENTORY_ALERTS" or 
	    event == "PLAYER_REGEN_ENABLED" or 
	    event == "PLAYER_MONEY" or 
	    event == "UNIT_INVENTORY_CHANGED") then
	    durability = CleanUI_GetPlayerDurability();
	    itemlevel = CleanUI_GetPlayerItemLevel();
 	end
 	
    if (event == "CALENDAR_UPDATE_PENDING_INVITES") then
        if ( CalendarGetNumPendingInvites() > 0 ) then
            CleanUI_ShowMinimapButtons();
        end
    end
 	
    if (event == "ACTIVE_TALENT_GROUP_CHANGED" or 
	    event == "UNIT_ENTERED_VEHICLE" or 
	    event == "UNIT_EXITED_VEHICLE" or 
	    event == "WORLD_MAP_UPDATE") then
        CleanUI_HideMicroButtons();
    end
    
    CleanUI_InitMinimapFrameStrata();
end

function CleanUI_CleanMicroButtons()
    
    CleanUIMicroButtonFrame:Show();
    
    CleanUIMicroButtonFrame:SetClampedToScreen(true);
    CleanUIMicroButtonFrame:SetWidth(312);
    CleanUIMicroButtonFrame:SetHeight(44);
    
    CleanUIMicroButtonFrame:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    CleanUIMicroButtonFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("LEFT", CleanUIMicroButtonFrame, "LEFT", 4, 10);
end

function CleanUI_CleanMinimap()
    
    CleanUIMicroButtonFrame:Hide();
    
    CleanUIMinimapBorder:SetBackdrop( { 
            --bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIMinimapBorder:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIMinimapButtons:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIMinimapButtons:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIMinimapDataBroker:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIMinimapDataBroker:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIMinimapBorder:Show();
    CleanUIMinimapBorderTop:Show();
    CleanUIMinimapBorderBottom:Show();
    CleanUIMinimapButtons:Show();
    CleanUIMinimapDataBroker:Show();

    --Minimap:SetMaskTexture("Interface/Buttons/WHITE8x8");
    Minimap:SetMaskTexture("Interface\\AddOns\\CleanUI\\skins\\minimap_masktexture");
	MinimapBorder:Hide();
	MinimapBorderTop:Hide();
	
    MinimapCluster:ClearAllPoints();
	MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", 10, -10); 
	
    TimeManagerClockButton:GetRegions():Hide();	
    TimeManagerClockButton:ClearAllPoints();
    TimeManagerClockButton:SetPoint("TOPRIGHT", CleanUIMinimapBorderBottom, "TOPRIGHT", 3, 2); 

    MinimapZoneTextButton:SetWidth(CleanUIMinimapBorderTop:GetWidth());
    MinimapZoneTextButton:SetHeight(CleanUIMinimapBorderTop:GetHeight());
    
    MinimapZoneTextButton:ClearAllPoints();
    MinimapZoneTextButton:SetPoint("TOPLEFT", CleanUIMinimapBorderTop, "TOPLEFT", 0, 0); 
    MinimapZoneTextButton:SetPoint("BOTTOMRIGHT", CleanUIMinimapBorderTop, "BOTTOMRIGHT", 0, 0); 
    
    MinimapZoneText:ClearAllPoints();
    MinimapZoneText:SetPoint("TOPLEFT", CleanUIMinimapBorderTop, "TOPLEFT", 0, 0); 
    MinimapZoneText:SetPoint("BOTTOMRIGHT", CleanUIMinimapBorderTop, "BOTTOMRIGHT", 0, 0); 

    MiniMapInstanceDifficulty:ClearAllPoints();
    MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -18, -16); 
    MiniMapInstanceDifficulty:SetFrameStrata("HIGH");
    
    GuildInstanceDifficulty:ClearAllPoints();
    GuildInstanceDifficulty:SetPoint("TOPRIGHT", MinimapCluster, "TOPRIGHT", -18, -16); 
    GuildInstanceDifficulty:SetFrameStrata("HIGH");
    
    MiniMapVoiceChatFrame:ClearAllPoints();
    MiniMapVoiceChatFrame:SetPoint("TOPLEFT", MinimapCluster, "BOTTOMLEFT", 30, 55);
    MiniMapVoiceChatFrameBackground:Hide();
    MiniMapVoiceChatFrameBorder:Hide();
    
    MiniMapRecordingButton:ClearAllPoints();
    MiniMapRecordingButton:SetPoint("TOPLEFT", MinimapCluster, "BOTTOMLEFT", 50, 55);
    MiniMapRecordingBorder:Hide();
    
    WatchFrame:ClearAllPoints();
    WatchFrame:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOMRIGHT", -CONTAINER_OFFSET_X, -20);
    WatchFrame:SetMovable(true);
    WatchFrame:SetUserPlaced();
    
    CleanUIMinimapBorderTop:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIMinimapBorderTop:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIMinimapBorderBottom:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIMinimapBorderBottom:SetBackdropColor(0.0, 0.0, 0.0, 1.0);

	for ii=1, #(microbutton_names), 1 do
	    local buttonname = microbutton_names[ii];
	    local button = _G[buttonname];
	    
	    button:HookScript("OnEnter", CleanUI_MicroButtonMouseOver);
	    button:HookScript("OnLeave", CleanUI_MicroButtonMouseOut);
	    
	    button:SetFrameStrata("DIALOG");
    end
    
	CleanUI_RelocateMicroButtons();
	CleanUI_HideMinimapInformation();
	
    if (HasNewMail()) then
        CleanUI_ShowMinimapButtons();
    else
        CleanUI_HideMinimapButtons();
    end
end

function CleanUI_RelocateMicroButtons()
    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 12, -75);
    SpellbookMicroButton:SetPoint("BOTTOMLEFT", CharacterMicroButton, "BOTTOMRIGHT", 3, 0);
    TalentMicroButton:SetPoint("BOTTOMLEFT", SpellbookMicroButton, "BOTTOMRIGHT", 3, 0);
    AchievementMicroButton:SetPoint("BOTTOMLEFT", TalentMicroButton, "BOTTOMRIGHT", 3, 0);
    
    QuestLogMicroButton:ClearAllPoints();
    QuestLogMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 12, -110);
    GuildMicroButton:SetPoint("BOTTOMLEFT", QuestLogMicroButton, "BOTTOMRIGHT", 3, 0);
    PVPMicroButton:SetPoint("BOTTOMLEFT", GuildMicroButton, "BOTTOMRIGHT", 3, 0);
    LFDMicroButton:SetPoint("BOTTOMLEFT", PVPMicroButton, "BOTTOMRIGHT", 3, 0);
    
    EJMicroButton:ClearAllPoints();
    EJMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 12, -145);
    RaidMicroButton:SetPoint("BOTTOMLEFT", EJMicroButton, "BOTTOMRIGHT", 3, 0);
    MainMenuMicroButton:SetPoint("BOTTOMLEFT", RaidMicroButton, "BOTTOMRIGHT", 3, 0);
    HelpMicroButton:SetPoint("BOTTOMLEFT", MainMenuMicroButton, "BOTTOMRIGHT", 3, 0);
end

function CleanUI_HideMicroButtons()

    CharacterMicroButton:ClearAllPoints();
    CharacterMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -75);
    QuestLogMicroButton:ClearAllPoints();
    QuestLogMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -110);
    EJMicroButton:ClearAllPoints();
    EJMicroButton:SetPoint("TOPLEFT", CleanUIMinimapBorderBottom, "TOPLEFT", 100009, -145);
end

function CleanUI_MicroButtonMouseOver(self)
	CleanUI_ShowMinimapInformation();
    mouseover = 1;
end

function CleanUI_MicroButtonMouseOut(self)
	CleanUI_HideMinimapInformation();
    mouseover = 0;
end

function CleanUI_InitMinimapButtons()
    GameTimeFrame:SetParent(CleanUIMinimapButtons);
    GameTimeFrame:ClearAllPoints();
    GameTimeFrame:SetPoint("TOPRIGHT", CleanUIMinimapButtons, "TOPRIGHT", -5, -6);
    GameTimeFrame:SetScale(0.6);
    GameTimeFrame:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    GameTimeFrame:HookScript("OnLeave", CleanUI_HideMinimapButtons);

    MiniMapTracking:SetParent(CleanUIMinimapButtons);
    MiniMapTracking:ClearAllPoints();
    MiniMapTracking:SetPoint("TOPRIGHT", CleanUIMinimapButtons, "TOPRIGHT", -5, -36);
    MiniMapTracking:SetScale(0.75);
    MiniMapTrackingButton:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapTrackingButton:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    
    local minimapZoneTextButton = _G["MinimapZoneTextButton"];
	minimapZoneTextButton:SetScript("OnClick", CleanUI_ToggleWorldMapFrame);
	minimapZoneTextButton:RegisterForClicks("AnyUp");
    
    MiniMapWorldMapButton:Hide();
    
    MiniMapMailFrame:SetParent(CleanUIMinimapButtons);
    MiniMapMailFrame:ClearAllPoints();
    MiniMapMailFrame:SetPoint("TOPRIGHT", CleanUIMinimapButtons, "TOPRIGHT", -4, -66);
    MiniMapMailFrame:SetScale(0.75);
    MiniMapMailFrame:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapMailFrame:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    
    MiniMapLFGFrame:SetParent(CleanUIMinimapButtons);
    MiniMapLFGFrame:ClearAllPoints();
    MiniMapLFGFrame:SetPoint("TOPRIGHT", CleanUIMinimapButtons, "TOPRIGHT", -4, -96);
    MiniMapLFGFrame:SetScale(0.75);
    MiniMapLFGFrame:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapLFGFrame:HookScript("OnLeave", CleanUI_HideMinimapButtons);
    
    MiniMapBattlefieldFrame:SetParent(CleanUIMinimapButtons);
    MiniMapBattlefieldFrame:ClearAllPoints();
    MiniMapBattlefieldFrame:SetPoint("TOPRIGHT", CleanUIMinimapButtons, "TOPRIGHT", -4, -126);
    MiniMapBattlefieldFrame:SetScale(0.75);
    MiniMapBattlefieldFrame:HookScript("OnEnter", CleanUI_ShowMinimapButtons);
    MiniMapBattlefieldFrame:HookScript("OnLeave", CleanUI_HideMinimapButtons);
end
    
function CleanUI_MinimapOnUpdate(self, elapsed)
    if (CleanUIData.CHANGE_MINIMAP ~= 1) then 
        return;
    end

	local player_x, player_y = CleanUI_GetPlayerPosition();
	
	CleanUIMinimapBorderBottom_tlocx:SetText(player_x);
	CleanUIMinimapBorderBottom_tlocy:SetText(player_y);
	CleanUIMinimapBorderBottom_money:SetText(money);
	CleanUIMinimapBorderBottom_durability:SetText(durability);
	CleanUIMinimapBorderBottom_itemlevel:SetText(itemlevel);
	
	-- work around
	if (mouseover == 0) then
	    TalentMicroButton:Hide();
	end
end

function CleanUI_GetPlayerPosition()
	local x, y = GetPlayerMapPosition("player");
	
	x = x * 100;
	y = y * 100;
	
	return "|cffffffff"..string.format("%.1f", x).."|r", "|cffffffff"..string.format("%.1f", y).."|r";
end

function CleanUI_GetPlayerMoney()
	local money = GetMoney();
	return "|cffffffff"..GetCoinTextureString(money).."|r";
end

function CleanUI_GetPlayerDurability()
	local total = 0;
	local count = 0;
	local color = "00ff00";

	for i = 1, #inv_slots do
		local dur = CleanUI_GetItemDurability(inv_slots[i]);
		
		if (dur >= 0) then
			total = total + dur;
			count = count + 1;
		end
	end
	
	if (count == 0) then
		total = 100;
	else	
	    total = floor(total / count * 100);
	end
	
	if (total > 66) then
		color = "00ff00";
	elseif (total > 19) then 
		color = "ffff00"
	else
		color = "ff0000"
	end
	
	return DURABILITY..": |cff"..color..total.." %|r";
end

function CleanUI_GetItemDurability(slot)
	if (not GetInventoryItemLink("player", slot)) then
		return -1;
	end
	
	local durability, maximum = GetInventoryItemDurability(slot);
	
	if (not durability or (maximum == 0)) then
		return -1;
	end
	
	return durability / maximum;
end

function CleanUI_GetPlayerItemLevel()
	local min = 0;
	local total = 0;
	local count = 0;

	for i = 1, #inv_slots do
		local itemLevel = CleanUI_GetItemLevel(inv_slots[i]);
		
		if (itemLevel >= 0) then
		    if (min == 0 or itemLevel < min) then
		        min = itemLevel;
		    end
		    
			total = total + itemLevel;
			count = count + 1;
		end
	end
	
	if (count == 0) then
		total = 0;
	else	
	    total = total / count;
	end
	
	return "|cffffffff"..string.format(ITEM_LEVEL_AND_MIN, total, min).."|r";
end

function CleanUI_GetItemLevel(slot)
	if (not GetInventoryItemLink("player", slot)) then
		return -1;
	end
	
	local itemLink = GetInventoryItemLink("player", slot);
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink);
	
	if (not itemLevel) then
		return -1;
	end
	
	return itemLevel;
end

function CleanUI_ToggleWorldMapFrame()
    ToggleFrame(WorldMapFrame);
end

function CleanUI_ShowMinimapButtons()
    CleanUIMinimapButtons:SetAlpha(1);
    CleanUIMinimapDataBroker:SetAlpha(1);
end

function CleanUI_HideMinimapButtons()
    CleanUIMinimapButtons:SetWidth(32);
    CleanUIMinimapButtons:SetAlpha(0);
    CleanUI_DataBroker_HideButtons();
    CleanUIMinimapDataBroker:SetAlpha(0);
end

function CleanUI_InitMinimapFrameStrata()
 	CleanUIMinimapBorderTop:SetFrameStrata("LOW");
 	CleanUIMinimapBorder:SetFrameStrata("LOW");
 	
 	Minimap:SetFrameStrata("BACKGROUND");
 	MinimapZoneTextButton:SetFrameStrata("HIGH");
 	MiniMapInstanceDifficulty:SetFrameStrata("HIGH");
 	
	for i, child in ipairs({Minimap:GetChildren()}) do
	    child:SetFrameStrata("HIGH");
	end
	
	for i, child in ipairs({MinimapBackdrop:GetChildren()}) do
	    child:SetFrameStrata("HIGH");
	end
end

function CleanUI_ShowMinimapInformation()
    CleanUIMinimapBorderBottom:SetHeight(210);
    
    CleanUIMinimapBorderBottom_money:Show();
    CleanUIMinimapBorderBottom_durability:Show();
    CleanUIMinimapBorderBottom_itemlevel:Show();
    CleanUIMinimapMasterVolume:Show();
    
	for ii=1, #(microbutton_names), 1 do
	    local buttonname = microbutton_names[ii];
	    local button = _G[buttonname];
	    
	    button:Show();
    end
    
    CleanUI_RelocateMicroButtons();
    
    mouseover = 1;
    
	local volume = tonumber(GetCVar("Sound_MasterVolume"));
    CleanUIMinimapMasterVolume:SetValue(volume);
end

function CleanUI_HideMinimapInformation()
    CleanUIMinimapBorderBottom:SetHeight(23);
    
    CleanUIMinimapBorderBottom_money:Hide();  
    CleanUIMinimapBorderBottom_durability:Hide();
    CleanUIMinimapBorderBottom_itemlevel:Hide();  
    CleanUIMinimapMasterVolume:Hide();
    
	CleanUI_HideMicroButtons();
    
    mouseover = 0;
end