function CleanUI_RaidOnEvent(self, event, ...)  
    if (CleanUIData.CHANGE_RAID ~= 1) then
        return;
    end

	if (event == "RAID_ROSTER_UPDATE") then	    
	    CleanUI_UpdateRaidFrame();
	end
	
	if (event == "RAID_TARGET_UPDATE") then
	end
end

function CleanUI_RaidHookEvents()
    if (CleanUIData.CHANGE_RAID == 1) then
        hooksecurefunc("CompactRaidGroup_UpdateBorder", CleanUI_CompactRaidGroup_UpdateBorder);
        hooksecurefunc("CompactRaidGroup_UpdateLayout", CleanUI_CompactRaidGroup_UpdateLayout);
        hooksecurefunc("CompactUnitFrame_UpdateSelectionHighlight", CleanUI_CompactUnitFrame_UpdateSelectionHighlight);
        hooksecurefunc("CompactUnitFrame_UpdateAggroHighlight", CleanUI_CompactUnitFrame_UpdateAggroHighlight);
        hooksecurefunc("DefaultCompactUnitFrameSetup", CleanUI_DefaultCompactUnitFrameSetup);
    end
end

function CleanUI_InitRaid()    
    if (CleanUIData.CHANGE_RAID == 1) then
        CleanUI_ChangeRaid();
    end
end

function CleanUI_ChangeRaid()
    CleanUI_UpdateRaidFrameManager();
    CleanUI_UpdateRaidFrame();
end

function CleanUI_UpdateRaidFrameManager()
    local raidFrameManager = _G["CompactRaidFrameManager"];             
    CleanUI_RemoveTextures(raidFrameManager);	 
 	
    raidFrameManager:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    raidFrameManager:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
            
    local displayFrame = _G["CompactRaidFrameManagerDisplayFrame"];             
    CleanUI_RemoveTextures(displayFrame);
            
    local toggleButton = _G["CompactRaidFrameManagerToggleButton"]; 
    toggleButton:SetNormalTexture("Interface\\AddOns\\CleanUI\\skins\\raidpanel-toggle");	
end

function CleanUI_UpdateRaidFrame() 	
            
    local raidFrame = _G["CompactRaidFrameContainer"];
            
    local rfBorderFrame = _G["CompactRaidFrameContainerBorderFrame"];            
    CleanUI_RemoveTextures(rfBorderFrame);
    
    for rg = 1, 8 do
        
        local raidGroup = _G["CompactRaidGroup"..rg]; 	
        --local raidGroupTitle = _G["CompactRaidGroup"..rg.."Title"]; 	
        
	    --raidGroupTitle:ClearAllPoints();
	    --raidGroupTitle:SetPoint("TOP", raidGroup, "TOP", 0, -2);     

        if (raidGroup) then    
            --[[local borderframe1 = _G["CUI_CompactRaidGroup"..rg.."Border1"];
            if (not borderframe1) then
                borderframe1 = CreateFrame("Frame", "CUI_CompactRaidGroup"..rg.."Border1", raidGroup);
            end
	
            borderframe1:SetBackdrop( { 
                    bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
                    edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
                    insets = { left = 4, right = 4, top = 4, bottom = 4 }
                });
            borderframe1:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
            borderframe1:SetPoint("TOPLEFT", -3, 0);
            borderframe1:SetPoint("BOTTOMRIGHT", 3, -3);]]
            
            local rgBorderFrame = _G["CompactRaidGroup"..rg.."BorderFrame"];            
            CleanUI_RemoveTextures(rgBorderFrame);
        end
    end
end

function CleanUI_CompactRaidGroup_UpdateLayout(frame)    
    CleanUI_UpdateRaidFrame();
end

function CleanUI_CompactRaidGroup_UpdateBorder(frame)       
	local showBorder = frame.borderFrame:IsVisible();
	
    for uu = 1, 5 do
        local unitFrame = _G[frame:GetName().."Member"..uu]; 
        
        unitFrame.healthBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        unitFrame.powerBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        
        unitFrame.myHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
        unitFrame.otherHealPredictionBar:SetStatusBarTexture(CleanUIData.CUI_STATUSBAR);
    
        local borderframe = CleanUI_CreateRaidBorderFrame(unitFrame);
        
        if ( showBorder ) then	
            borderframe:Show();
        else
            borderframe:Hide();
        end
    end
    
    for pp = 1, 40 do
        local frame = _G["CompactRaidFrame"..pp];
        
        if (frame) then
            CleanUI_CreateRaidBorderFrame(frame);
        end
    end
end

function CleanUI_CreateRaidBorderFrame(frame)  	

    -- status color
    frame.statusText:SetTextColor(0.7, 0.7, 0.7);

    -- orig. textures
   	frame.background:SetTexture(nil);  
   	
   	frame.horizDivider:SetTexture(nil);  	
   	frame.horizTopBorder:SetTexture(nil);  	
   	frame.horizBottomBorder:SetTexture(nil);  	
   	frame.vertLeftBorder:SetTexture(nil);  	
   	frame.vertRightBorder:SetTexture(nil);
    
    frame.healthBar.background:SetTexture(nil);
    frame.powerBar.background:SetTexture(nil);
    
    -- new border            
    local borderframe = _G[frame:GetName().."Border"];
    if (not borderframe) then
        borderframe = CreateFrame("Frame", frame:GetName().."Border", frame);
    end
    
    borderframe:SetBackdrop( {  
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    borderframe:SetPoint("TOPLEFT", -3, 1);
    borderframe:SetPoint("BOTTOMRIGHT", 2, -2);	
    
    frame.borderframe = borderframe;
    
    return borderframe;
end

function CleanUI_DefaultCompactUnitFrameSetup(frame)
	local options = DefaultCompactUnitFrameSetupOptions;
	
	if ( options.displayPowerBar ) then
		frame.powerBar:SetPoint("TOPLEFT", frame.healthBar, "BOTTOMLEFT", 0, 0);
	end
end

function CleanUI_CompactUnitFrame_UpdateSelectionHighlight(frame)
	local options = DefaultCompactUnitFrameSetupOptions;

    if (not frame.borderframe) then
        return;
    end
	
    if (not options.displayBorder) then
		frame.borderframe:Hide();
        return;
    end
    
	if ( not frame.optionTable.displaySelectionHighlight ) then
		frame.borderframe:Show();
		return;
	end
	
	if ( UnitIsUnit(frame.displayedUnit, "target") ) then
		frame.borderframe:Hide();
	else
		frame.borderframe:Show();
	end
end

function CleanUI_CompactUnitFrame_UpdateAggroHighlight(frame)
	local options = DefaultCompactUnitFrameSetupOptions;
	
    if (not frame.borderframe or not options.displayBorder) then
        return;
    end
	
    if (not options.displayBorder) then
		frame.borderframe:Hide();
        return;
    end
    
	if ( not frame.optionTable.displayAggroHighlight ) then
		frame.borderframe:Show();
		return;
	end
	
	local status = UnitThreatSituation(frame.displayedUnit);
	if ( status and status > 0 ) then
		frame.borderframe:Hide();
	else
		frame.borderframe:Show();
	end
end