-- 	DEFAULT_CHAT_FRAME:AddMessage("CleanUI_FactionChange", 1.0, 1.0, 1.0, 1, 10);

local max_time = 120; -- seconds

local starttime = 0;

function CleanUI_ReputationOnEvent(self, event, ...)
-- UPDATE_FACTION
    if (event == "CHAT_MSG_COMBAT_FACTION_CHANGE") then
        local message = ...;
        CleanUI_FactionChange(message);
    end
end

function CleanUI_ReputationHookEvents()
    hooksecurefunc("SetWatchedFactionIndex", CleanUI_SetWatchedFactionIndex);
end
    
function CleanUI_CleanReputationWatchBar()
end
    
function CleanUI_SetWatchedFactionIndex(faction)
    if (faction > 0) then
		starttime = GetTime();
    else
	    starttime = 0;
    end
end
    
function CleanUI_ReputationOnUpdate(self, elapsed)
    CleanUI_ReputationUpdate();
end

function CleanUI_FactionChange(message)
	local faction = CleanUI_CheckReputationMessage(message);
	
	if (faction ~= nil) then
		SetWatchedFactionIndex(faction);
		--starttime = GetTime();
	else
	    CleanUI_HideWatchedFaction();
	end
end

function CleanUI_ReputationUpdate()

    local time = GetTime();
    
    if (time - starttime > max_time) then
        CleanUI_HideWatchedFaction();
    end
end

function CleanUI_HideWatchedFaction()
    SetWatchedFactionIndex(0);
	--starttime = 0;
end

function CleanUI_CheckReputationMessage(message)

    -- use guild name
    if (string.find(message,GUILD)) then
        local guildName, guildRankName, guildRankIndex = GetGuildInfo("player");
        message = "'"..guildName.."'";
    end

	local index = 1;	
	
	repeat
		local name, description, standingID, barMin, barMax, barValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(index);
		
		if (name ~= nil and string.find(message,name) ~= nil) then
			barMax = barMax - barMin;
			barValue = barValue - barMin;	
			
			local pct = 100 * barValue / barMax;
			
			local info = HIGHLIGHT_FONT_COLOR_CODE.." "..barValue.." / "..barMax.." ("..format("%d", pct).." %)"..FONT_COLOR_CODE_CLOSE;
		    DEFAULT_CHAT_FRAME:AddMessage(name..": "..info, 1.0, 1.0, 1.0, 1, 10);
			
			return index;
		end
		
		index = index + 1;
		
	until (index > 200);
	
	return nil;
end