local oldname = nil;

function CleanUI_EquipmentSetsOnEvent(self, event, ...)
end

function CleanUI_TalentsHookEvents()
	hooksecurefunc("UnitPopup_ShowMenu", CleanUI_Talents_ShowMenu);   
end

function CleanUI_Talents_ShowMenu(dropdownMenu, which, unit, name, userData)

    if (unit ~= "player" or UIDROPDOWNMENU_MENU_LEVEL > 1) then
	    return;
	end
    
    if (GetNumTalentGroups() > 1) then
        local eq_header = UIDropDownMenu_CreateInfo();
        eq_header.text = TALENTS;
        eq_header.isNotRadio = true;
        eq_header.notCheckable = 1;
        eq_header.isTitle = true;    
        UIDropDownMenu_AddButton(eq_header);
        
	    local activeTalentGroup = GetActiveTalentGroup();

        for ii=1, GetNumTalentGroups() do
            local name = CleanUI_DetectTalentName(ii);
        
            local info = UIDropDownMenu_CreateInfo();
            info.text = name;
            info.func = function(frame) CleanUI_SelectTalentSet(ii) end;
            
            if (ii == activeTalentGroup) then
                info.checked = true;
            end
            
            UIDropDownMenu_AddButton(info);
        end
        
    end
end

function CleanUI_DetectTalentName(targetTalentGroup)	
	local _pointsSpent = 0;
	local _icon = TALENT_HYBRID_ICON;
	
    local targetTalentName = "";
    local targetTalentPoints = "";
	
	for i = 1, MAX_TALENT_TABS do
		local id, name, description, icon, pointsSpent, background, previewPointsSpent, isUnlocked = GetTalentTabInfo(i, false, false, targetTalentGroup);
		
		if (name ~= nil) then
		     
			if (pointsSpent > _pointsSpent) then
				_pointsSpent = pointsSpent;
				targetTalentName = name;
			end
		end
		
		if (i == 1) then
		    targetTalentPoints = targetTalentPoints..pointsSpent;
		else
		    targetTalentPoints = targetTalentPoints.."/"..pointsSpent;
		end
	end
	
	return targetTalentName.." ("..targetTalentPoints..")";
end

function CleanUI_SelectTalentSet(targetTalentGroup)
    SetActiveTalentGroup(targetTalentGroup);
end