function CleanUI_ThreatFrameOnEvent(self, event, ...)
    if (event == "UNIT_THREAT_LIST_UPDATE" or event == "UNIT_THREAT_SITUATION_UPDATE") then
        CleanUI_ThreatFrameUpdate();
    end
end

function CleanUI_ThreatFrameOnUpdate(self, elapsed)
    CleanUI_ThreatFrameUpdate();
end

function CleanUI_InitThreatBars()

    local parent = CleanUIThreatFrame;
    local rel = "TOP";
    
    parent:EnableMouse(false);
    
    for i = 1, 10 do
        local threatbar = CreateFrame("StatusBar", "CleanUIThreatFrame_threat"..i, CleanUIThreatFrame, "CleanUIThreadBarTemplate");
        threatbar:ClearAllPoints();
        threatbar:SetPoint("TOP", parent, rel, 0, -1);
        threatbar:SetHeight(18);
        rel = "BOTTOM";
        
        local threatbar_a = CreateFrame("StatusBar", "CleanUIThreatFrame_threat"..i.."a", threatbar, "CleanUIThreadBarTemplate");
        threatbar_a:ClearAllPoints();
        threatbar_a:SetPoint("TOP", threatbar, rel, 0, 0);
        threatbar_a:SetHeight(6);
        parent = threatbar_a;
        
        threatbar:Hide();
    end
    
    local threatbar_p = CreateFrame("StatusBar", "CleanUIThreatFrame_threatp", CleanUIThreatFrame, "CleanUIThreadBarTemplate");
    threatbar_p:ClearAllPoints();
    threatbar_p:SetPoint("TOP", CleanUIThreatFrame, "TOP", 0, -1);
    threatbar_p:SetHeight(24);
    
    threatbar_p:Hide();
end

function CleanUI_ThreatFrame_OnMouseDown(frame, button)
    if (button == "RightButton") then
        if (IsControlKeyDown()) then
            CleanUIThreatFrame:StartMoving();
        end
    end
end

function CleanUI_ThreatFrame_OnMouseUp(frame, button)
    if (button == "RightButton") then
        CleanUIThreatFrame:StopMovingOrSizing();
    end
end

function CleanUI_ThreatFrameUpdate()
    
    local alpha = CleanUIData.THREATFRAME_ALPHA or 1;
    CleanUIThreatFrame:SetAlpha(alpha);
    
    local threat = {};
    local units = CleanUI_GetUnitIds();    
    local index = 1;
    
    local status1, threatpct1, rawthreatpct1, status2, threatpct2, rawthreatpct2 = nil, nil, nil, nil, nil, nil;

    if (not CUI_CONFIG_SHOWN) then
        if (CleanUIData.SHOW_THREATFRAME ~= 1) then
            CleanUIThreatFrame:Hide();
            return;
        else
            CleanUIThreatFrame:Show();
        end
    
        if (not InCombatLockdown()) then
            CleanUIThreatFrame:Hide();
            return;
        else
            CleanUIThreatFrame:Show();
        end  
    
        for i, id in pairs(units) do
            
            if(UnitExists("target")) then
                _, status1, threatpct1, rawthreatpct1, _ = UnitDetailedThreatSituation(id, "target");
            end
                
            if(UnitExists(id.."target")) then
                _, status2, threatpct2, rawthreatpct2, _ = UnitDetailedThreatSituation("player", id.."target");
            end
            
            if (threatpct1 or threatpct2) then
            
                if (CleanUIData.THREATFRAME_RAWPCT == 1) then
                    threat[index] = {unit = id, s1 = status1, s2 = status2, t1 = rawthreatpct1, t2 = rawthreatpct2};
                else
                    threat[index] = {unit = id, s1 = status1, s2 = status2, t1 = threatpct1, t2 = threatpct2};
                end
                
                index = index + 1;
            end
        end
    else
        -- Demo fr Config
        CleanUIThreatFrame:Show();
        threat[1] = {unit = "player", s1 = 3, s2 = 0, t1 = 100, t2 = 29};
    end
	
	table.sort(threat, CleanUI_SortThreat);
	
	local playerInList = false;
	local playerbar = _G["CleanUIThreatFrame_threatp"];
	
    index = 1;
    
    local max_threatvalue = 100;    
    if (CleanUIData.THREATFRAME_RAWPCT == 1) then
        max_threatvalue = 130;
    end
	        
	for i, data in pairs(threat) do
	
	    if (i > 10) then
	        break;
	    end
	
	    index = i;	    
	    
	    local unit = data.unit;
	    local status1 = data.s1 or 0;
	    local status2 = data.s2 or 0;
	    local threatpct1 = data.t1 or 0;
	    local threatpct2 = data.t2 or 0;
	    
        local bar1 = _G["CleanUIThreatFrame_threat"..i];
        local bar2 = _G["CleanUIThreatFrame_threat"..i.."a"];
	    
	    if (unit ~= "player") then	    
            bar1:Show();  
	        bar2:Show();
            
	        bar1:SetMinMaxValues(0, max_threatvalue);
	        bar2:SetMinMaxValues(0, max_threatvalue);            
            bar1:SetValue(threatpct1);
            bar2:SetValue(threatpct2);
            
            local r1, g1, b1 = GetThreatStatusColor(status1);
            local r2, g2, b2 = GetThreatStatusColor(status2);            
            bar1:SetStatusBarColor(r1, g1, b1);
            bar2:SetStatusBarColor(r2, g2, b2);

            _G["CleanUIThreatFrame_threat"..i.."UnitName"]:SetText(UnitName(unit));
            _G["CleanUIThreatFrame_threat"..i.."UnitName"]:SetFontObject(GameFontNormalSmall);
            _G["CleanUIThreatFrame_threat"..i.."Value"]:SetText(format("%.0f", threatpct1).." %");
	    else	    
            bar1:Hide();
            bar2:Hide();
            playerInList = true;
            
            local y_offset = (i-1) * 25;
            playerbar:ClearAllPoints();
            playerbar:SetPoint("TOP", CleanUIThreatFrame, "TOP", 0, -y_offset - 1);
            
	        playerbar:SetMinMaxValues(0, max_threatvalue);	        
            playerbar:SetValue(threatpct1);
            
            local r, g, b = GetThreatStatusColor(status1);            
            playerbar:SetStatusBarColor(r, g, b);
            
            _G["CleanUIThreatFrame_threatpUnitName"]:SetText(UnitName("player"));
            _G["CleanUIThreatFrame_threatpUnitName"]:SetFontObject(GameFontNormal); --GameFontNormalLarge
            _G["CleanUIThreatFrame_threatpValue"]:SetText(format("%.0f", threatpct1).." %");
	    end
	end
	
	for i=index+1, 10 do
	    local bar1 = _G["CleanUIThreatFrame_threat"..i];
	    local bar2 = _G["CleanUIThreatFrame_threat"..i.."a"];	
	    
	    if (bar1) then
            bar1:SetValue(0);
            bar1:Hide(); 
	    end
	    
	    if (bar2) then            
            bar2:SetValue(0);
            bar2:Hide();
	    end
	end
	
	if (playerbar) then
        if (playerInList) then
            playerbar:Show();
        else
            playerbar:Hide();
        end
    end
end

function CleanUI_SortThreat(a, b)

    if (a and b) then
        local at1 = a.t1 or 0;
        local bt1 = b.t1 or 0;
        --local at2 = a.t2 or 0;
        --local bt2 = b.t2 or 0;
            
        if (at1 > bt1) then
            return true;
        end
    end
    
    return false;
end

function CleanUI_GetUnitIds()

	local numRaidMembers = GetNumRaidMembers();

    local units = {"player"};
    local index = 2;
    
    if (numRaidMembers > 0) then
        for i=1, MAX_RAID_MEMBERS do
            if ( i <= numRaidMembers ) then
                local unit = "raid"..i;
                if(UnitExists(unit) and UnitName(unit) ~= UnitName("player")) then
                    units[index] = unit;
                    index = index + 1;
                end
            end
        end
    else
        for i=1, 4, 1 do
            local unit = "party"..i;
            if(UnitExists(unit)) then
                units[index] = unit;
                index = index + 1;
            end
        end
    end

    return units;
end