local MASQUE = LibStub("Masque", true);
local buttongroup = nil;

local PLAYER_BAROFFSET = 73;
local PLAYER_BARWIDTH = 154;
local TARGET_BARWIDTH = 154;

-- no animations
PlayerFrame_AnimateOut = function (self) CleanUI_UnitFrames_NoVehicleArt(1); end;
PlayerFrame_UpdateArt = function (self) CleanUI_UnitFrames_NoVehicleArt(2); end;
--PartyMemberFrame_UpdateArt = function (self) CleanUI_UnitFrames_NoVehicleArt(3); end;

function CleanUI_UnitFrames_NoVehicleArt(value)
end

function CleanUI_UnitFramesOnEvent(self, event, ...)
	if (event == "ADDON_LOADED") then
		local addonName = ...;
		if (addonName == "CleanUI") then		
		    if (MASQUE) then
                buttongroup = MASQUE:Group("CleanUI");
            end
        end
    end
    if (event == "PARTY_MEMBERS_CHANGED") then
        CleanUI_CheckClassColors();
        CleanUI_PartyMemberFrame_UpdateArt(self);
    end
    if (event == "UNIT_AURA" or event == "UNIT_COMBAT") then
        CleanUI_ColorizeRuneFrame();
        CleanUI_UpdateShapeshiftForm();
    end
    if (event == "UNIT_PORTRAIT_UPDATE") then
        local unit = ...;
 	    CleanUI_UpdatePortrait(unit);
    end
    if (event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateShapeshiftForm();
        CleanUI_InitPortrait3DModels();
        CleanUI_InitPortraitClassIcons();
        CleanUI_SetPortraitTexture(PlayerPortrait, "player");
		CleanUI_StartDelay(CUI_START_DELAY, CleanUI_ColorizeRuneFrame);       
    end
    if (event == "UPDATE_SHAPESHIFT_FORM" or event == "UPDATE_SHAPESHIFT_USABLE") then
        CleanUI_UpdateShapeshiftForm();
    end
    if (event == "PLAYER_REGEN_ENABLED") then
        CleanUI_RebindUnitFrames();
    end
    
    CleanUI_InitUnitTextures();
	CleanUI_InitUnitDrawLayer();
end

function CleanUI_RebindUnitFrames()

    if (InCombatLockdown()) then
        return;
    end
	
	if (UnitExists("pet")) then
	    UnitFrame_SetUnit(PetFrame, "pet", PetFrameHealthBar, PetFrameManaBar);
	    PetFrame:Show();
	else
	    PetFrame:Hide();
	end
        
    local numRaidMembers = GetNumRaidMembers();
    
    if (numRaidMembers > 0) then
        -- in raid
    else
        for i = 1, 4 do
            if (UnitExists("party"..i)) then
                UnitFrame_SetUnit(_G["PartyMemberFrame"..i], "party"..i, _G["PartyMemberFrame"..i.."HealthBar"], _G["PartyMemberFrame"..i.."ManaBar"]);
                _G["PartyMemberFrame"..i]:Show();
            else
                _G["PartyMemberFrame"..i]:Hide();
            end
            if (UnitExists("partypet"..i)) then
                UnitFrame_SetUnit(_G["PartyMemberFrame"..i.."PetFrame"], "partypet"..i, _G["PartyMemberFrame"..i.."PetFrameHealthBar"], nil);
                _G["PartyMemberFrame"..i.."PetFrame"]:Show();
            else
                _G["PartyMemberFrame"..i.."PetFrame"]:Hide();
            end
        end
    end
end

function CleanUI_UnitFramesHookEvents()
    hooksecurefunc("UnitFrame_UpdateTooltip", CleanUI_UnitFrame_UpdateTooltip);
    hooksecurefunc("PlayerFrame_ToPlayerArt", CleanUI_PlayerFrame_UpdateArt);
    hooksecurefunc("PlayerFrame_ToVehicleArt", CleanUI_PlayerFrame_UpdateArt);
    hooksecurefunc("PartyMemberFrame_ToPlayerArt", CleanUI_PartyMemberFrame_UpdateArt);
    hooksecurefunc("PartyMemberFrame_ToVehicleArt", CleanUI_PartyMemberFrame_UpdateArt);
    hooksecurefunc("PartyMemberFrame_UpdatePet", CleanUI_PartyMemberFrame_UpdatePet);
    hooksecurefunc("SetPortraitTexture", CleanUI_SetPortraitTexture);
    hooksecurefunc("BossTargetFrame_OnLoad", CleanUI_BossTargetFrame_OnLoad);
    hooksecurefunc("TargetFrame_UpdateAuras", CleanUI_TargetFrame_UpdateAuras);
    
	hooksecurefunc(Boss1TargetFrame, "SetPoint", CleanUI_MoveBossTargetFrames);
end

function CleanUI_UnitFramesOnUpdate(self, elapsed)
    CleanUI_UpdatePaladinPowerBar(elapsed);
    
    local playerborder = _G["CUI_PlayerFrameBorder1"];
    if (playerborder) then
        local isSelfCast = false;
        
        local modifiedClick = GetModifiedClick("SELFCAST");
        if (modifiedClick == "ALT" and IsAltKeyDown()) then
            isSelfCast = true;                
        elseif (modifiedClick == "CTRL" and IsControlKeyDown()) then
            isSelfCast = true;                
        elseif (modifiedClick == "SHIFT" and IsShiftKeyDown()) then
            isSelfCast = true;                
        end
        
        if (isSelfCast) then
            playerborder:SetBackdropColor(1.0, 0.0, 0.0, 1.0);
            playerborder:SetBackdropBorderColor(1.0, 0.0, 0.0, 1.0);
        else
            playerborder:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
            playerborder:SetBackdropBorderColor(1.0, 1.0, 1.0, 1.0);
        end
    end

	local focusborder = _G["CUI_FocusFrameBorder2"];
    if (focusborder) then
        local isFocusCast = false;
        
        local modifiedClick = GetModifiedClick("FOCUSCAST");
        if (modifiedClick == "ALT" and IsAltKeyDown()) then
            isFocusCast = true;                
        elseif (modifiedClick == "CTRL" and IsControlKeyDown()) then
            isFocusCast = true;                
        elseif (modifiedClick == "SHIFT" and IsShiftKeyDown()) then
            isFocusCast = true;                
        end
        
        if (isFocusCast) then
            focusborder:SetBackdropColor(1.0, 0.0, 0.0, 1.0);
            focusborder:SetBackdropBorderColor(1.0, 0.0, 0.0, 1.0);
        else
            focusborder:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
            focusborder:SetBackdropBorderColor(1.0, 1.0, 1.0, 1.0);
        end
    end
end

function CleanUI_InitUnitFrames()
    CleanUI_InitUnitTextures();
    CleanUI_InitUnitFrameUI();
    
	CleanUI_ColorizeRuneFrame();
    CleanUI_MoveComboFrameIcons();
    
    CleanUI_MakeFramesMovable();
    
    CleanUI_MovePlayerIcons();
    CleanUI_MovePartyIcons();
    CleanUI_MovePetIcons();
    CleanUI_MoveTargetIcons();
    CleanUI_MoveFocusIcons();
    CleanUI_CheckClassColors();    
    
    CleanUI_BossTargetIcons(_G["Boss1TargetFrame"]);
    CleanUI_BossTargetIcons(_G["Boss2TargetFrame"]);    
    CleanUI_BossTargetIcons(_G["Boss3TargetFrame"]);
    CleanUI_BossTargetIcons(_G["Boss4TargetFrame"]);
    
    CleanUITargetSpellbarBorder:SetBackdrop( { 
            --bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUITargetSpellbarBorder:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIFocusSpellbarBorder:SetBackdrop( { 
            --bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
    CleanUIFocusSpellbarBorder:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    PartyMemberBuffTooltip:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    PartyMemberBuffTooltip:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    cui_unitframes_loaded = true;
end

function CleanUI_TargetFrame_UpdateAuras(self)  

    -- ButtonFacade
    if (MASQUE and buttongroup) then 	
        for i=1, MAX_TARGET_BUFFS do
            buttongroup:RemoveButton(_G[self:GetName().."Buff"..i]);
            buttongroup:AddButton(_G[self:GetName().."Buff"..i]);
        end
        
        for i=1, MAX_TARGET_DEBUFFS do
            buttongroup:RemoveButton(_G[self:GetName().."Debuff"..i]);
            buttongroup:AddButton(_G[self:GetName().."Debuff"..i]);
        end
    end
    
    -- Stealable
    local canAssist = UnitCanAssist("player", self.unit);

    local filter;
    if ( SHOW_CASTABLE_BUFFS == "1" and canAssist ) then
        filter = "RAID";
    end

    for i=1, MAX_TARGET_BUFFS do	
		frameName = self:GetName().."Buff"..i;
	    local playerIsTarget = UnitIsUnit(PlayerFrame.unit, self.unit);
        
        local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable = UnitBuff(self.unit, i, filter);

        -- Show stealable frame if the target is not a player and the buff is stealable.
        frameStealable = _G[frameName.."Stealable"];
        
        if (frameStealable) then
        
            frameStealable:ClearAllPoints();
            frameStealable:SetPoint("TOPLEFT", _G[frameName], "TOPLEFT", -4, 4);
            frameStealable:SetPoint("BOTTOMRIGHT", _G[frameName], "BOTTOMRIGHT", 4, -4);
        
            if ( not playerIsTarget and isStealable ) then
                frameStealable:Show();
            else
                frameStealable:Hide();
            end
        end
    end
end

function CleanUI_MakeFramesMovable()
    PlayerFrame:SetMovable(true);
    TargetFrame:SetMovable(true);
    FocusFrame:SetMovable(true);
    PartyMemberFrame1:SetMovable(true);
    PartyMemberFrame2:SetMovable(true);
    PartyMemberFrame3:SetMovable(true);
    PartyMemberFrame4:SetMovable(true);
    
    PlayerFrame:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	PlayerFrame:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    TargetFrame:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	TargetFrame:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    FocusFrame:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	FocusFrame:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    PartyMemberFrame1:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	PartyMemberFrame1:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    PartyMemberFrame2:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	PartyMemberFrame2:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    PartyMemberFrame3:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	PartyMemberFrame3:HookScript("OnMouseUp", CleanUI_OnMouseUp);
    PartyMemberFrame4:HookScript("OnMouseDown", CleanUI_OnMouseDown);
	PartyMemberFrame4:HookScript("OnMouseUp", CleanUI_OnMouseUp);
	
	if (not CleanUIData.unitFramePositions) then
        CleanUIData.unitFramePositions = {};
        CleanUIData.unitFramePositions["PlayerFrame"] = nil;
        CleanUIData.unitFramePositions["TargetFrame"] = nil;
        CleanUIData.unitFramePositions["FocusFrame"] = nil;
        CleanUIData.unitFramePositions["PartyMemberFrame1"] = nil;
        CleanUIData.unitFramePositions["PartyMemberFrame2"] = nil;
        CleanUIData.unitFramePositions["PartyMemberFrame3"] = nil;
        CleanUIData.unitFramePositions["PartyMemberFrame4"] = nil;
	end
end

function CleanUI_LoadFramePosition(self, def_x, def_y)
    local name = self:GetName();
    
    local position = CleanUIData.unitFramePositions[name];
    
    if (position) then
        local point = position.p;
        local relativeTo = _G[position.rt];
        local relativePoint = position.rp;
        local x = position.x;
        local y = position.y;
        
        if (not point) then
            point = "TOPLEFT";
        end
        
        if (not relativeTo) then
            relativeTo = UIParent;
        end
        
        if (not relativePoint) then
            relativePoint = "TOPLEFT";
        end
        
        self:ClearAllPoints();
        self:SetPoint(point, relativeTo, relativePoint, x, y);
    else
        self:ClearAllPoints();
        self:SetPoint("TOPLEFT", UIParent, "TOPLEFT", def_x, def_y);
        
        CleanUI_SaveFramePosition(self, "TOPLEFT", UIParent, "TOPLEFT", def_x, def_y)
    end
end

function CleanUI_SaveFramePosition(self, point, relativeTo, relativePoint, posx, posy)

    local name = self:GetName();
    
    if (not relativeTo) then
        relativeTo = UIParent;
    end
    
    CleanUIData.unitFramePositions[name] = { p = point, rt = relativeTo:GetName(), rp = relativePoint, x = posx, y = posy };
    
    self:ClearAllPoints();
    self:SetPoint(point, relativeTo, relativePoint, posx, posy);
end

function CleanUI_OnMouseDown(self, button)
    if (button == "RightButton") then
        if (IsControlKeyDown()) then
            self:StartMoving();
        end
    end
end

function CleanUI_OnMouseUp(self, button)
    if (button == "RightButton") then
        self:StopMovingOrSizing();
        
        local point, relativeTo, relativePoint, x, y = self:GetPoint();
        
        CleanUI_SaveFramePosition(self, point, relativeTo, relativePoint, x, y);
    end
end

function CleanUI_InitPortrait3DModels()
    local playerModelFrame = CreateFrame("PlayerModel", "CUI_PlayerModelFrame", PlayerFrame);
    playerModelFrame:SetWidth(62);
    playerModelFrame:SetHeight(62);
    playerModelFrame:ClearAllPoints();
    playerModelFrame:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 4, -4);
    playerModelFrame:SetFrameStrata("BACKGROUND");
    playerModelFrame:SetScript("OnShow", function(self) self:SetCamera(0) end);
	
	local targetModelFrame = CreateFrame("PlayerModel", "CUI_TargetModelFrame", TargetFrame);
    targetModelFrame:SetWidth(62);
    targetModelFrame:SetHeight(62);
    targetModelFrame:ClearAllPoints();
    targetModelFrame:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 166, -4);
    targetModelFrame:SetFrameStrata("BACKGROUND");
    targetModelFrame:SetScript("OnShow", function(self) self:SetCamera(0) end);
	
	local focusModelFrame = CreateFrame("PlayerModel", "CUI_FocusModelFrame", FocusFrame);
    focusModelFrame:SetWidth(62);
    focusModelFrame:SetHeight(62);
    focusModelFrame:ClearAllPoints();
    focusModelFrame:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 166, -4);
    focusModelFrame:SetFrameStrata("BACKGROUND");
    focusModelFrame:SetScript("OnShow", function(self) self:SetCamera(0) end);
	
    for i=1, 4, 1 do
    
        local partyFrame = _G["PartyMemberFrame"..i];
            
        local partyModelFrame = CreateFrame("PlayerModel", "CUI_Party"..i.."ModelFrame", partyFrame);
        partyModelFrame:SetWidth(40);
        partyModelFrame:SetHeight(40);
        partyModelFrame:ClearAllPoints();
        partyModelFrame:SetPoint("TOPLEFT", partyFrame, "TOPLEFT", 4, -4);
        partyModelFrame:SetFrameStrata("LOW");
        partyModelFrame:SetScript("OnShow", function(self) self:SetCamera(0) end);
        
        local help = _G["CUI_Party"..i.."BGFrame"];
        if (not help) then
            help = CreateFrame("Frame", "CUI_Party"..i.."BGFrame", partyFrame);
    
            help:SetBackdrop( { 
                bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
                tile = true, tileSize = 16, edgeSize = 16, 
                insets = { left = 0, right = 0, top = 0, bottom = 0 }
            });
            
            help:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
        end
        help:SetWidth(40);
        help:SetHeight(40);
        help:ClearAllPoints();
        help:SetPoint("TOPLEFT", partyFrame, "TOPLEFT", 4, -4);
    end
end

function CleanUI_InitPortraitClassIcons()
    local playerModelFrame = CreateFrame("Frame", "CUI_PlayerClassIcon", PlayerFrame);
    playerModelFrame:SetWidth(62);
    playerModelFrame:SetHeight(62);
    playerModelFrame:ClearAllPoints();
    playerModelFrame:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 4, -4);
    playerModelFrame:SetFrameStrata("BACKGROUND");
    
	local playerClassIcon = playerModelFrame:CreateTexture(playerModelFrame:GetName().."Icon", "ARTWORK");
    playerClassIcon:ClearAllPoints();
    playerClassIcon:SetPoint("TOPLEFT", 0, 0);
    playerClassIcon:SetPoint("BOTTOMRIGHT", 0, 0);
    
	
    local targetModelFrame = CreateFrame("Frame", "CUI_TargetClassIcon", TargetFrame);
    targetModelFrame:SetWidth(62);
    targetModelFrame:SetHeight(62);
    targetModelFrame:ClearAllPoints();
    targetModelFrame:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 166, -4);
    targetModelFrame:SetFrameStrata("BACKGROUND");
    
	local targetClassIcon = targetModelFrame:CreateTexture(targetModelFrame:GetName().."Icon", "ARTWORK");
    targetClassIcon:ClearAllPoints();
    targetClassIcon:SetPoint("TOPLEFT", 0, 0);
    targetClassIcon:SetPoint("BOTTOMRIGHT", 0, 0);
    
	
    local focusModelFrame = CreateFrame("Frame", "CUI_FocusClassIcon", FocusFrame);
    focusModelFrame:SetWidth(62);
    focusModelFrame:SetHeight(62);
    focusModelFrame:ClearAllPoints();
    focusModelFrame:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 166, -4);
    focusModelFrame:SetFrameStrata("BACKGROUND");
    
	local focusClassIcon = focusModelFrame:CreateTexture(focusModelFrame:GetName().."Icon", "ARTWORK");
    focusClassIcon:ClearAllPoints();
    focusClassIcon:SetPoint("TOPLEFT", 0, 0);
    focusClassIcon:SetPoint("BOTTOMRIGHT", 0, 0);
	
    for i=1, 4, 1 do
    
        local partyFrame = _G["PartyMemberFrame"..i];
	
        local partyModelFrame = CreateFrame("Frame", "CUI_Party"..i.."ClassIcon", partyFrame);
        partyModelFrame:SetWidth(40);
        partyModelFrame:SetHeight(40);
        partyModelFrame:ClearAllPoints();
        partyModelFrame:SetPoint("TOPLEFT", partyFrame, "TOPLEFT", 4, -4);
        partyModelFrame:SetFrameStrata("LOW");
        
        local partyClassIcon = partyModelFrame:CreateTexture(partyModelFrame:GetName().."Icon", "ARTWORK");
        partyClassIcon:ClearAllPoints();
        partyClassIcon:SetPoint("TOPLEFT", 0, 0);
        partyClassIcon:SetPoint("BOTTOMRIGHT", 0, 0);
    end
end

function CleanUI_InitPortraitType(modelFrame, classiconFrame, unit)
    if (CleanUIData.PORTRAIT_STYLE == 1) then       -- 3D portrait
        if (modelFrame) then
            modelFrame:Show();
            
            modelFrame:ClearModel();
            modelFrame:SetUnit(unit);
            modelFrame:SetCamera(0);
        end
        if (classiconFrame) then
            classiconFrame:Hide();
        end
    elseif (CleanUIData.PORTRAIT_STYLE == 2) then   -- class icon
        if (classiconFrame) then
            classiconFrame:Show();
            
            local _, classToken = UnitClass(unit);
            if (classToken) then
                local classicon = _G[classiconFrame:GetName().."Icon"];
                local coords = CLASS_BUTTONS[classToken];
                classicon:SetTexture("Interface\\WorldStateFrame\\Icons-Classes");
                classicon:SetTexCoord(coords[1], coords[2], coords[3], coords[4]);
            end
        end
        if (modelFrame) then
            modelFrame:Hide();
        end
    end
end

function CleanUI_ToggleDpsFrameVisibility()
    if (CleanUIData.SHOW_DPS == 1) then
        CleanUIPlayerDpsFrame:Show();
    else
        CleanUIPlayerDpsFrame:Hide();
    end
    
    if (CleanUIData.SHOW_DPSINFO == 1) then
        CleanUIPlayerDpsFrameStatusBarDps:Show();
    else
        CleanUIPlayerDpsFrameStatusBarDps:Hide();
    end
end

function CleanUI_UpdateAllPortraits()
    CleanUI_UpdatePortrait("player");
    CleanUI_UpdatePortrait("target");
    CleanUI_UpdatePortrait("focus");
    CleanUI_UpdatePortrait("party1");
    CleanUI_UpdatePortrait("party2");
    CleanUI_UpdatePortrait("party3");
    CleanUI_UpdatePortrait("party4");
end

function CleanUI_UpdatePortrait(unit)
    if (unit == "player") then
        CleanUI_InitPortraitType(_G["CUI_PlayerModelFrame"], _G["CUI_PlayerClassIcon"], unit);
    elseif (unit == "target") then
        CleanUI_InitPortraitType(_G["CUI_TargetModelFrame"], _G["CUI_TargetClassIcon"], unit);
    elseif (unit == "focus") then
        CleanUI_InitPortraitType(_G["CUI_FocusModelFrame"], _G["CUI_FocusClassIcon"], unit);
    elseif (unit == "party1") then
        CleanUI_InitPortraitType(_G["CUI_Party1ModelFrame"], _G["CUI_Party1ClassIcon"], unit);
    elseif (unit == "party2") then
        CleanUI_InitPortraitType(_G["CUI_Party2ModelFrame"], _G["CUI_Party2ClassIcon"], unit);
    elseif (unit == "party3") then
        CleanUI_InitPortraitType(_G["CUI_Party3ModelFrame"], _G["CUI_Party3ClassIcon"], unit);
    elseif (unit == "party4") then
        CleanUI_InitPortraitType(_G["CUI_Party4ModelFrame"], _G["CUI_Party4ClassIcon"], unit);
    end
end

function CleanUI_SetPortraitTexture(portraitframe, unit)
    if (portraitframe) then
 	    if (portraitframe:GetName() == "PlayerPortrait") then
	        CleanUI_InitPortraitType(_G["CUI_PlayerModelFrame"], _G["CUI_PlayerClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "TargetFramePortrait") then
	        CleanUI_InitPortraitType(_G["CUI_TargetModelFrame"], _G["CUI_TargetClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "FocusFramePortrait") then
	        CleanUI_InitPortraitType(_G["CUI_FocusModelFrame"], _G["CUI_FocusClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "PartyMemberFrame1Portrait") then
	        CleanUI_InitPortraitType(_G["CUI_Party1ModelFrame"], _G["CUI_Party1ClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "PartyMemberFrame2Portrait") then
	        CleanUI_InitPortraitType(_G["CUI_Party2ModelFrame"], _G["CUI_Party2ClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "PartyMemberFrame3Portrait") then
	        CleanUI_InitPortraitType(_G["CUI_Party3ModelFrame"], _G["CUI_Party3ClassIcon"], unit);
 	    elseif (portraitframe:GetName() == "PartyMemberFrame4Portrait") then
	        CleanUI_InitPortraitType(_G["CUI_Party4ModelFrame"], _G["CUI_Party4ClassIcon"], unit);
 	    end
 	end
end

function CleanUI_CheckClassColors()

    CleanUI_SetClassColors("player", PlayerName);
    
    for i=1, 4, 1 do
        CleanUI_SetClassColors("party"..i, _G["PartyMemberFrame"..i.."Name"]);
    end
end

function CleanUI_SetClassColors(unit, text)
    local _, class = UnitClass(unit);
    
    local classTextColor;
	if (class) then
		classTextColor = RAID_CLASS_COLORS[class];
	else
		classTextColor = NORMAL_FONT_COLOR;
	end
    text:SetTextColor(classTextColor.r, classTextColor.g, classTextColor.b);
end

function CleanUI_InitUnitFrameUI()
    -- new bars
    local playerAggroBar = CreateFrame("StatusBar", "CUI_PlayerAggroBar", PlayerFrame, "CleanUIPlayerAggroBarTemplate");
    
    playerAggroBar:SetWidth(PLAYER_BARWIDTH);
    playerAggroBar:SetHeight(22);
	playerAggroBar:ClearAllPoints();
    playerAggroBar:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", PLAYER_BAROFFSET, -5);
    playerAggroBar:EnableMouse(false);
    
    local petAggroBar = CreateFrame("StatusBar", "CUI_PetAggroBar", PetFrame, "CleanUIPetAggroBarTemplate");
 
    petAggroBar:SetBackdrop(nil);

    petAggroBar:SetHeight(12);
    petAggroBar:SetFrameStrata("LOW");
    petAggroBar:ClearAllPoints();
    petAggroBar:SetPoint("TOP", PetFrame, "TOP", 0, -4);
    petAggroBar:EnableMouse(false);
	
	-- Fokus entfernen
	local removeFocusButton = CreateFrame("Button", "CUI_RemoveFocusButton", FocusFrame, "CleanUIFocusButtonTemplate");
	removeFocusButton:SetScale(1);
    removeFocusButton:ClearAllPoints();
    removeFocusButton:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 230, 2);
	removeFocusButton:SetAttribute("type", "macro");
	removeFocusButton:SetAttribute("macrotext", "/clearfocus");
   
	removeFocusButton:SetNormalTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	removeFocusButton:SetHighlightTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	removeFocusButton:SetPushedTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	
	local removeFocusButtonIcon = _G["CUI_RemoveFocusButtonIcon"];
	removeFocusButtonIcon:SetTexture("Interface\\AddOns\\CleanUI\\skins\\clearfocus");
	
	_G["CUI_RemoveFocusButtonBorder"]:Hide();
	_G["CUI_RemoveFocusButtonNormalTexture"]:Hide();
		
	-- Party
    for i=1, 4, 1 do
        -- party aggrobar
        local partyFrame = _G["PartyMemberFrame"..i];
        local partyAggroBar = CreateFrame("StatusBar", "CUI_Party"..i.."AggroBar", partyFrame, "CleanUIPartyAggroBarTemplate");
        
        partyAggroBar:SetWidth(103);
        partyAggroBar:SetHeight(12)
	
        partyAggroBar:SetFrameStrata("LOW");
        partyAggroBar:ClearAllPoints();
        partyAggroBar:SetPoint("LEFT", partyFrame, "LEFT", 50, 14);
        
        -- party pet manabar
        local partyPetManaBar = CreateFrame("StatusBar", "CUI_Party"..i.."PetManaBar", _G["PartyMemberFrame"..i.."PetFrame"], "CleanUIPartyPetManaBarTemplate");
        partyPetManaBar:ClearAllPoints();
        partyPetManaBar:SetPoint("CENTER", _G["PartyMemberFrame"..i.."PetFrame"], "CENTER", 0, -15);
        partyPetManaBar:SetFrameStrata("LOW");
    
        -- party pet aggrobar
        local partyPetFrame = _G["PartyMemberFrame"..i.."PetFrame"];
        local partyPetAggroBar = CreateFrame("StatusBar", "CUI_Party"..i.."PetAggroBar", _G["PartyMemberFrame"..i.."PetFrame"], "CleanUIPartyPetAggroBarTemplate");
	
        partyPetAggroBar:SetFrameStrata("LOW");
        partyPetAggroBar:ClearAllPoints();
        partyPetAggroBar:SetPoint("CENTER", partyPetFrame, "CENTER", 0, 14);
        
        --party pet name
        local partyPetName = partyPetFrame:CreateFontString("CUI_Party"..i.."PetName", "ARTWORK");
        partyPetName:SetFontObject("GameFontNormalSmall");
        partyPetName:SetWidth(66);
        partyPetName:SetHeight(10);
        partyPetName:ClearAllPoints(); 
        partyPetName:SetPoint("CENTER", _G["PartyMemberFrame"..i.."PetFrame"], "CENTER", 0, 15);
        partyPetName:SetJustifyH("CENTER");
        partyPetName:SetText("");
    end
    
    local targetHealthBarPercent = TargetFrame:CreateFontString("CUI_TargetHealthBarPercent", "OVERLAY");
	targetHealthBarPercent:SetFontObject("SystemFont_Outline_Small");
    targetHealthBarPercent:SetWidth(50);
    targetHealthBarPercent:SetHeight(10);
    targetHealthBarPercent:ClearAllPoints(); 
    targetHealthBarPercent:SetPoint("RIGHT", TargetFrameHealthBar, "RIGHT", 42, 0);
    targetHealthBarPercent:SetTextColor(1.0, 1.0, 1.0, 1.0);
    targetHealthBarPercent:SetJustifyH("RIGHT");
    targetHealthBarPercent:SetText("");
    
    local targetManaBarPercent = TargetFrame:CreateFontString("CUI_TargetManaBarPercent", "OVERLAY");
	targetManaBarPercent:SetFontObject("SystemFont_Outline_Small");
    targetManaBarPercent:SetWidth(50);
    targetManaBarPercent:SetHeight(10);
    targetManaBarPercent:ClearAllPoints(); 
    targetManaBarPercent:SetPoint("RIGHT", TargetFrameManaBar, "RIGHT", 42, 0);
    targetManaBarPercent:SetTextColor(1.0, 1.0, 1.0, 1.0);
    targetManaBarPercent:SetJustifyH("RIGHT");
    targetManaBarPercent:SetText("");
    
    local targetInfo = TargetFrame:CreateFontString("CUI_TargetInfo", "ARTWORK");
	targetInfo:SetFontObject("GameFontNormalSmall");
    targetInfo:SetWidth(200);
    targetInfo:SetHeight(10);
    targetInfo:SetTextColor(1.0, 1.0, 1.0, 1.0);
    targetInfo:SetTextHeight(8);
    targetInfo:SetText("");
    
    local focusHealthBarPercent = FocusFrame:CreateFontString("CUI_FocusHealthBarPercent", "OVERLAY");
	focusHealthBarPercent:SetFontObject("SystemFont_Outline_Small");
    focusHealthBarPercent:SetWidth(50);
    focusHealthBarPercent:SetHeight(10);
    focusHealthBarPercent:ClearAllPoints(); 
    focusHealthBarPercent:SetPoint("RIGHT", FocusFrameHealthBar, "RIGHT", 42, 0);
    focusHealthBarPercent:SetTextColor(1.0, 1.0, 1.0, 1.0);
    focusHealthBarPercent:SetJustifyH("RIGHT");
    focusHealthBarPercent:SetText("");
    
    local focusManaBarPercent = FocusFrame:CreateFontString("CUI_FocusManaBarPercent", "OVERLAY");
	focusManaBarPercent:SetFontObject("SystemFont_Outline_Small");
    focusManaBarPercent:SetWidth(50);
    focusManaBarPercent:SetHeight(10);
    focusManaBarPercent:ClearAllPoints(); 
    focusManaBarPercent:SetPoint("RIGHT", FocusFrameManaBar, "RIGHT", 42, 0);
    focusManaBarPercent:SetTextColor(1.0, 1.0, 1.0, 1.0);
    focusManaBarPercent:SetJustifyH("RIGHT");
    focusManaBarPercent:SetText("");
    
    local focusInfo = FocusFrame:CreateFontString("CUI_FocusInfo", "ARTWORK");
	focusInfo:SetFontObject("GameFontNormalSmall");
    focusInfo:SetWidth(200);
    focusInfo:SetHeight(10);
    focusInfo:SetTextColor(1.0, 1.0, 1.0, 1.0);
    focusInfo:SetTextHeight(8);
    focusInfo:SetText("");
    
    local targetTabbedInfo = TargetFrame:CreateFontString("CUI_TargetTabbedInfo", "OVERLAY");
	targetTabbedInfo:SetFontObject("NumberFontNormalHuge");
	targetTabbedInfo:SetTextHeight(24);
    targetTabbedInfo:SetWidth(200);
    targetTabbedInfo:SetHeight(100);
    targetTabbedInfo:SetTextColor(1.0, 0.2, 0.2);
    targetTabbedInfo:ClearAllPoints(); 
    targetTabbedInfo:SetPoint("CENTER", TargetFrame, "CENTER", 82, 15);
    targetTabbedInfo:SetText("");
    
    local focusTabbedInfo = FocusFrame:CreateFontString("CUI_FocusTabbedInfo", "OVERLAY");
	focusTabbedInfo:SetFontObject("NumberFontNormalHuge");
	focusTabbedInfo:SetTextHeight(24);
    focusTabbedInfo:SetWidth(200);
    focusTabbedInfo:SetHeight(100);
    focusTabbedInfo:SetTextColor(1.0, 0.2, 0.2);
    focusTabbedInfo:ClearAllPoints(); 
    focusTabbedInfo:SetPoint("CENTER", FocusFrame, "CENTER", 82, 15);
    focusTabbedInfo:SetText("");
    
    local targetEliteTexture = TargetFrame:CreateTexture("CUI_TargetFrameEliteTexture", "OVERLAY");
    targetEliteTexture:ClearAllPoints(); 
    targetEliteTexture:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 152, 18);
    targetEliteTexture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\gold_dragon");
    targetEliteTexture:SetWidth(110);
    targetEliteTexture:SetHeight(110);
    targetEliteTexture:Hide();
    
    local targetRareTexture = TargetFrame:CreateTexture("CUI_TargetFrameRareTexture", "OVERLAY");
    targetRareTexture:ClearAllPoints(); 
    targetRareTexture:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 152, 18);
    targetRareTexture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\silver_dragon");
    targetRareTexture:SetWidth(110);
    targetRareTexture:SetHeight(110);
    targetRareTexture:Hide();
    
    local focusEliteTexture = FocusFrame:CreateTexture("CUI_FocusFrameEliteTexture", "OVERLAY");
    focusEliteTexture:ClearAllPoints(); 
    focusEliteTexture:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 152, 18);
    focusEliteTexture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\gold_dragon");
    focusEliteTexture:SetWidth(110);
    focusEliteTexture:SetHeight(110);
    focusEliteTexture:Hide();
    
    local focusRareTexture = FocusFrame:CreateTexture("CUI_FocusFrameRareTexture", "OVERLAY");
    focusRareTexture:ClearAllPoints(); 
    focusRareTexture:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 152, 18);
    focusRareTexture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\silver_dragon");
    focusRareTexture:SetWidth(110);
    focusRareTexture:SetHeight(110);
    focusRareTexture:Hide();
    
    for i = 1, MAX_BOSS_FRAMES do
        local texture = _G["Boss"..i.."TargetFrame"]:CreateTexture("CUI_Boss"..i.."TargetFrameEliteTexture", "OVERLAY");
        texture:ClearAllPoints(); 
        texture:SetPoint("TOPLEFT", _G["Boss"..i.."TargetFrame"], "TOPLEFT", 58, 18);
        texture:SetTexture("Interface\\AddOns\\CleanUI\\skins\\gold_dragon");
        texture:SetWidth(110);
        texture:SetHeight(105);
    end
end

function CleanUI_UnitFrame_UpdateTooltip(self)

    local name, id = GameTooltip:GetUnit();
    
    if (name == UnitName("player")) then
        cui_party_xp[name] = {level=UnitLevel("player"), xp=UnitXP("player"), xpmax=UnitXPMax("player"), xpexhaustion=GetXPExhaustion()};
    end
    
    if (cui_party_xp[name] == nil or cui_party_xp[name].xp == nil or cui_party_xp[name].xpmax == nil) then
        return;
    end
    
    local level =  tonumber(cui_party_xp[name].level);
    
    if (level < MAX_PLAYER_LEVEL) then
        local xp =  tonumber(cui_party_xp[name].xp);
        local xpmax =  tonumber(cui_party_xp[name].xpmax);
        local pxp = 100 * xp / xpmax;
            
        GameTooltip:AddLine(" ");
        GameTooltip:AddLine("|c333399ffXP:|r |cffffffff"..xp.."/"..xpmax.."  (|r"..format("%d", pxp).." %|cffffffff)|r");
            
        GameTooltip:AppendText("");
    end
end

function CleanUI_ColorizeRuneFrame()
    RuneFrame:SetBackdropBorderColor(1.0, 1.0, 1.0, 1.0);
    
    local _, class = UnitClass("player");
	
	if ( class == "DEATHKNIGHT" ) then    
        for index = 1,25 do
            local _, _, _, _, _, _, _, _, _, _, spellId = UnitAura("player", index);
            if (spellId == 48266) then    -- Frost: 48266
                RuneFrame:SetBackdropBorderColor(0.0, 0.5, 1.0, 1.0);
                return;
            elseif (spellId == 48263) then        -- Blut: 48263
                RuneFrame:SetBackdropBorderColor(1.0, 0.0, 0.0, 1.0);
                return;
            elseif (spellId == 48265) then    -- Unheilig: 48265
                RuneFrame:SetBackdropBorderColor(0.0, 0.5, 0.0, 1.0);
                return;
            end
        end
    end
    
    -- Blutschild -> Hintergrund?
    --RuneFrame:SetBackdropColor(0.0, 0.5, 1.0, 1.0);
end

function CleanUI_SetWhiteStatusTexture(textureframe, parent)
    if (not parent) then 
        return;
    end
    
    textureframe:SetTexture("Interface\\AddOns\\CleanUI\\skins\\CleanUI-UnitStatus-White");
    textureframe:SetTexCoord(0, 1, 0, 1);
    textureframe:ClearAllPoints();
    textureframe:SetPoint("TOPLEFT", parent, "TOPLEFT", 3, -3);
    textureframe:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT", -3, 3);
end

function CleanUI_SetRedStatusTexture(textureframe, parent)
    if (not parent) then 
        return;
    end
    
    textureframe:SetTexture("Interface\\AddOns\\CleanUI\\skins\\CleanUI-UnitStatus-Red");
    textureframe:SetTexCoord(0, 1, 0, 1);
    textureframe:ClearAllPoints();
    textureframe:SetPoint("TOPLEFT", parent, "TOPLEFT", 3, -3);
    textureframe:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT", -3, 3);
end

function CleanUI_MoveComboFrameIcons()
    ComboFrame:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    ComboFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);	
    
    ComboFrame:SetWidth(118);
    ComboFrame:SetHeight(32);
    
    ComboFrame:ClearAllPoints();
	ComboFrame:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 68, -68);
    
    local width = 20;
    local height = 24;
		
	for i=1, MAX_COMBO_POINTS do
		comboPoint = _G["ComboPoint"..i];
		
	    comboPoint:SetWidth(width);
	    comboPoint:SetHeight(height);
	    comboPoint:ClearAllPoints();
        comboPoint:SetPoint("LEFT", ComboFrame, "LEFT", 4 + ((i-1) * (width+2)), 0);
        
        _G["ComboPoint"..i.."Highlight"]:SetTexture("Interface\\AddOns\\CleanUI\\skins\\combopoints\\"..i);
        _G["ComboPoint"..i.."Highlight"]:SetTexCoord(0, 1, 0, 1);
	    _G["ComboPoint"..i.."Highlight"]:ClearAllPoints();
        _G["ComboPoint"..i.."Highlight"]:SetPoint("TOPLEFT", comboPoint, "TOPLEFT", 0, 0);
        _G["ComboPoint"..i.."Highlight"]:SetPoint("BOTTOMRIGHT", comboPoint, "BOTTOMRIGHT", 0, 0);
        --_G["ComboPoint"..i.."Shine"]:SetTexture();
	
        for i, child in ipairs({comboPoint:GetRegions()}) do
            if (not child:GetName()) then
                child:SetTexture();
            end
        end
    end
end

function CleanUI_InitUnitTextures()	
	-- Player
    PlayerFrameTexture:Hide();
    PlayerFrameVehicleTexture:Hide();
    PlayerFrameBackground:Hide();
    PlayerPortrait:Hide();
    PlayerAttackBackground:Hide();
    
    CleanUI_SetWhiteStatusTexture(PlayerStatusTexture, CUI_PlayerFrameBorder2);
    CleanUI_SetRedStatusTexture(PlayerFrameFlash, CUI_PlayerFrameBorder2);
    
	local _, class = UnitClass("player");
	
	if (RuneFrame) then
	    RuneFrame:SetWidth(118);
	    RuneFrame:SetHeight(32);
        RuneFrame:ClearAllPoints();
	    RuneFrame:SetPoint("TOPLEFT", PlayerFrame, "BOTTOMLEFT", 68, 2);
	end
	
	if (TotemFrame) then
	    TotemFrame:SetWidth(118);
	    TotemFrame:SetHeight(32);
        TotemFrame:ClearAllPoints();
	    TotemFrame:SetPoint("TOPLEFT", PlayerFrame, "BOTTOMLEFT", 68, 2);
	end
	
	if (ShardBarFrame) then
        ShardBarFrame:SetWidth(118);
        ShardBarFrame:SetHeight(32);	    
        ShardBarFrame:ClearAllPoints();
        ShardBarFrame:SetPoint("TOPLEFT", PlayerFrame, "BOTTOMLEFT", 68, 2);
	end
	
	if (EclipseBarFrame) then         
        EclipseBarFrame:SetWidth(118);
        EclipseBarFrame:SetHeight(32);   
        EclipseBarFrame:ClearAllPoints();
        EclipseBarFrame:SetPoint("TOPLEFT", PlayerFrame, "BOTTOMLEFT", 68, 2);
        
        EclipseBarFrameBar:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameSun:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameMoon:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameDarkSun:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameDarkMoon:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameSunBar:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameMoonBar:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameMarker:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");        
        EclipseBarFrameGlow:SetTexture("Interface\\AddOns\\CleanUI\\skins\\druid_eclipse");
        
        EclipseBarFrameBar:SetDrawLayer("OVERLAY");    
        EclipseBarFrameSun:SetDrawLayer("OVERLAY");      
        EclipseBarFrameMoon:SetDrawLayer("OVERLAY");      
        EclipseBarFrameDarkSun:SetDrawLayer("OVERLAY");       
        EclipseBarFrameDarkMoon:SetDrawLayer("OVERLAY");       
        EclipseBarFrameSunBar:SetDrawLayer("OVERLAY");       
        EclipseBarFrameMoonBar:SetDrawLayer("OVERLAY");        
        EclipseBarFrameMarker:SetDrawLayer("OVERLAY");       
        EclipseBarFrameGlow:SetDrawLayer("OVERLAY");
        
        EclipseBarFrameBar:SetWidth(130);
        EclipseBarFrameSunBar:SetWidth(130);
        EclipseBarFrameMoonBar:SetWidth(130);
        
        EclipseBarFrameDarkSun:ClearAllPoints();
        EclipseBarFrameDarkSun:SetPoint("RIGHT", EclipseBarFrame, "RIGHT", -3, 0);        
        EclipseBarFrameSun:ClearAllPoints();
        EclipseBarFrameSun:SetPoint("RIGHT", EclipseBarFrame, "RIGHT", -3, 0);
        
        EclipseBarFrameDarkMoon:ClearAllPoints();
        EclipseBarFrameDarkMoon:SetPoint("LEFT", EclipseBarFrame, "LEFT", 3, 0);        
        EclipseBarFrameMoon:ClearAllPoints();
        EclipseBarFrameMoon:SetPoint("LEFT", EclipseBarFrame, "LEFT", 3, 0);
	end
	
	if (PaladinPowerBar) then     
        PaladinPowerBar:SetWidth(118);
        PaladinPowerBar:SetHeight(32);      
        PaladinPowerBar:ClearAllPoints();
        PaladinPowerBar:SetPoint("TOPLEFT", PlayerFrame, "BOTTOMLEFT", 68, 2);
	end
    
    -- Pet
    PetFrameTexture:Hide();
    PetPortrait:Hide();    
    CleanUI_SetWhiteStatusTexture(PetFrameFlash, PetFrame);
    CleanUI_SetRedStatusTexture(PetAttackModeTexture, PetFrame);
    
    -- Target
    TargetFrameBackground:Hide();
    TargetFrameNameBackground:Hide();
    TargetFrameTextureFrameTexture:Hide();
    TargetFramePortrait:Hide();
    
    CleanUI_SetWhiteStatusTexture(TargetFrameFlash, CUI_TargetFrameBorder1);
	
    TargetFrameToTPortrait:Hide();
    TargetFrameToTBackground:Hide();
    TargetFrameToTTextureFrameTexture:Hide();
    
    -- Focus
    FocusFrameBackground:Hide();
    FocusFrameNameBackground:Hide();
    FocusFrameTextureFrameTexture:Hide();
    FocusFramePortrait:Hide();
    
    CleanUI_SetWhiteStatusTexture(FocusFrameFlash, CUI_FocusFrameBorder1);
	
    FocusFrameToTPortrait:Hide();
    FocusFrameToTBackground:Hide();
    FocusFrameToTTextureFrameTexture:Hide();
    
    -- Party
	for i=1, 4, 1 do    
        _G["PartyMemberFrame"..i.."Portrait"]:Hide();
        _G["PartyMemberFrame"..i.."Texture"]:Hide();
        _G["PartyMemberFrame"..i.."VehicleTexture"]:Hide();
        _G["PartyMemberFrame"..i.."Background"]:Hide();
    
        _G["PartyMemberFrame"..i.."PetFramePortrait"]:Hide();
        _G["PartyMemberFrame"..i.."PetFrameTexture"]:Hide();
        
        CleanUI_SetRedStatusTexture(_G["PartyMemberFrame"..i.."PetFrameFlash"], _G["PartyMemberFrame"..i.."PetFrame"]);       
	end	
        
    CleanUI_SetRedStatusTexture(_G["PartyMemberFrame1Flash"], CUI_PartyFrameBorder21);        
    CleanUI_SetWhiteStatusTexture(_G["PartyMemberFrame1Status"], CUI_PartyFrameBorder21);
    CleanUI_SetRedStatusTexture(_G["PartyMemberFrame2Flash"], CUI_PartyFrameBorder22);        
    CleanUI_SetWhiteStatusTexture(_G["PartyMemberFrame2Status"], CUI_PartyFrameBorder22);
    CleanUI_SetRedStatusTexture(_G["PartyMemberFrame3Flash"], CUI_PartyFrameBorder23);        
    CleanUI_SetWhiteStatusTexture(_G["PartyMemberFrame3Status"], CUI_PartyFrameBorder23);
    CleanUI_SetRedStatusTexture(_G["PartyMemberFrame4Flash"], CUI_PartyFrameBorder24);        
    CleanUI_SetWhiteStatusTexture(_G["PartyMemberFrame4Status"], CUI_PartyFrameBorder24);
    
    CleanUI_SetWhiteStatusTexture(Boss1TargetFrameFlash, CUI_Boss1TargetFrameBorderFrame);
    CleanUI_SetWhiteStatusTexture(Boss2TargetFrameFlash, CUI_Boss2TargetFrameBorderFrame);
    CleanUI_SetWhiteStatusTexture(Boss3TargetFrameFlash, CUI_Boss3TargetFrameBorderFrame);
    CleanUI_SetWhiteStatusTexture(Boss4TargetFrameFlash, CUI_Boss4TargetFrameBorderFrame);
    
	CleanUI_InitUnitDrawLayer();
end

function CleanUI_InitUnitDrawLayer()
    PlayerStatusTexture:SetDrawLayer("OVERLAY");
    PlayerFrameFlash:SetDrawLayer("ARTWORK");
    PetFrameFlash:SetDrawLayer("ARTWORK");
    PetAttackModeTexture:SetDrawLayer("OVERLAY");
    TargetFrameFlash:SetDrawLayer("ARTWORK");
    FocusFrameFlash:SetDrawLayer("ARTWORK");
    
    Boss1TargetFrameFlash:SetDrawLayer("ARTWORK");
    Boss2TargetFrameFlash:SetDrawLayer("ARTWORK");
    Boss3TargetFrameFlash:SetDrawLayer("ARTWORK");
    Boss4TargetFrameFlash:SetDrawLayer("ARTWORK");
    
	for i=1, 4, 1 do
        _G["PartyMemberFrame"..i.."Flash"]:SetDrawLayer("OVERLAY");
        _G["PartyMemberFrame"..i.."Status"]:SetDrawLayer("OVERLAY");
        _G["PartyMemberFrame"..i.."PetFrameFlash"]:SetDrawLayer("OVERLAY");
	end
end

function CleanUI_MovePlayerIcons()
    CleanUI_MovePlayerDefaultIcons();
end

function CleanUI_MovePartyIcons()
    for i = 1, 4 do
        PartyMemberFrame_UpdateArt(_G["PartyMemberFrame"..i]);
    end
end

function CleanUI_PlayerFrame_UpdateArt(self)
    CleanUI_StartDelay(4, CleanUI_MovePlayerDefaultIcons);
end

function CleanUI_PartyMemberFrame_UpdateArt(self)
 	local i = self:GetID();
 	local unit = "party"..i;
	
	if (UnitExists(unit)) then
	    CleanUI_MovePartyDefaultIcons(i);
    end
end

function CleanUI_MovePlayerDefaultIcons()    
    CleanUI_LoadFramePosition(PlayerFrame, 5, -10);
    
    PlayerFrame:SetWidth(232);
    PlayerFrame:SetHeight(70);
    PlayerFrame:SetHitRectInsets(0, 0, 0, 0);
    
	local borderframe1 = _G["CUI_PlayerFrameBorder1"];
    if (not borderframe1) then
        borderframe1 = CreateFrame("Frame", "CUI_PlayerFrameBorder1", PlayerFrame);
	end
	borderframe1:SetPoint("TOPLEFT", 0, 0);
    borderframe1:SetWidth(70);
    borderframe1:SetHeight(70);
    borderframe1:SetFrameStrata("BACKGROUND");
    
    borderframe1:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe1:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
	local borderframe2 = _G["CUI_PlayerFrameBorder2"];
    if (not borderframe2) then
        borderframe2 = CreateFrame("Frame", "CUI_PlayerFrameBorder2", PlayerFrame);
	end
	borderframe2:SetPoint("TOPRIGHT", 0, 0);
    borderframe2:SetWidth(164);
    borderframe2:SetHeight(70);
    borderframe2:SetFrameStrata("BACKGROUND");
    
    borderframe2:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe2:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUIPlayerDpsFrame:ClearAllPoints();
	CleanUIPlayerDpsFrame:SetPoint("TOPLEFT", borderframe1, "BOTTOMLEFT", 0, 2);
    CleanUIPlayerDpsFrame:SetFrameStrata("BACKGROUND");
    
    CleanUIPlayerDpsFrame:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    CleanUIPlayerDpsFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    CleanUI_ToggleDpsFrameVisibility();    
    
    PlayerFrameTexture:Hide();
    PlayerFrameVehicleTexture:Hide();
    PlayerFrameBackground:Hide();
    PlayerPortrait:Hide();
    
    PlayerName:ClearAllPoints();
	PlayerName:SetPoint("LEFT", 20, 24);
    PlayerName:SetWidth(200);
    PlayerName:SetJustifyH("LEFT");
	
    PlayerFrameReadyCheck:ClearAllPoints();
	PlayerFrameReadyCheck:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 10, -15);
	
    PlayerLeaderIcon:ClearAllPoints();
	PlayerLeaderIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 3, -3);
	
    PlayerMasterIcon:ClearAllPoints();
	PlayerMasterIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 3, -15);
	
    PlayerGuideIcon:ClearAllPoints();
	PlayerGuideIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 50, -50);
	
    PlayerFrameRoleIcon:ClearAllPoints();
	PlayerFrameRoleIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 50, -50);
	
    PlayerLevelText:ClearAllPoints();
	PlayerLevelText:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 8, -54);
	
    PlayerRestIcon:ClearAllPoints();
	PlayerRestIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 21, -46);
	
    PlayerRestGlow:ClearAllPoints();
	PlayerRestGlow:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 21, -49);
    
    PlayerAttackIcon:ClearAllPoints();
	PlayerAttackIcon:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 20, -52);
	PlayerAttackIcon:SetTexCoord(0.5, 1.0, 0, 0.49);
    
    PlayerAttackGlow:ClearAllPoints();
	PlayerAttackGlow:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 20, -52);
    
    PlayerAttackBackground:ClearAllPoints();
	PlayerAttackBackground:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 2, 100); -- out of screen
    
    PlayerPVPIcon:ClearAllPoints();
	PlayerPVPIcon:SetPoint("CENTER", PlayerFrame, "RIGHT", 8, -15);
    
    PlayerPVPTimerText:ClearAllPoints();
	PlayerPVPTimerText:SetPoint("CENTER", PlayerPVPIcon, "CENTER", -8, -10);
    PlayerPVPTimerText:SetDrawLayer("OVERLAY"); 
	
	PlayerHitIndicator:ClearAllPoints();
	PlayerHitIndicator:SetPoint("TOPLEFT", PlayerFrame, "TOPLEFT", 15, -20);
	
	-- non shaman totem
    local button = _G["TotemFrameTotem1"];
    button:ClearAllPoints();
    button:SetPoint("CENTER", PlayerFrame, "RIGHT", 22, 0);

	-- class specific
	local _, class = UnitClass("player");	
	if ( class == "DEATHKNIGHT") then	    
	    RuneFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
        RuneFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
        
        RuneButtonIndividual1:SetPoint("LEFT", RuneFrame, "LEFT", 9, 0);
        RuneButtonIndividual2:SetPoint("LEFT", RuneButtonIndividual1, "RIGHT", 3, 0);
        RuneButtonIndividual3:SetPoint("LEFT", RuneButtonIndividual2, "RIGHT", 6, 0);
        RuneButtonIndividual4:SetPoint("LEFT", RuneButtonIndividual3, "RIGHT", 3, 0);
        RuneButtonIndividual5:SetPoint("LEFT", RuneButtonIndividual4, "RIGHT", 6, 0);  
        RuneButtonIndividual6:SetPoint("LEFT", RuneButtonIndividual5, "RIGHT", 3, 0);
        
        for i = 1, 6 do
            _G["RuneButtonIndividual"..i]:SetScale(0.8);
        end

	elseif ( class == "SHAMAN" ) then	    
	    TotemFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
        TotemFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
        
        TotemFrameTotem1:SetPoint("TOPLEFT", TotemFrame, "TOPLEFT", 6, -3);
        TotemFrameTotem2:SetPoint("LEFT", TotemFrameTotem1, "RIGHT", -1, 0);
        TotemFrameTotem3:SetPoint("LEFT", TotemFrameTotem2, "RIGHT", -1, 0);
        TotemFrameTotem4:SetPoint("LEFT", TotemFrameTotem3, "RIGHT", -1, 0);      
        
        for i = 1, 4 do
            local button = _G["TotemFrameTotem"..i];
            button:SetScale(0.75);
            
            local duration = _G["TotemFrameTotem"..i.."Duration"];
            duration:ClearAllPoints();
            duration:SetPoint("CENTER", button, "CENTER", 0, 0);
        end
	elseif ( class == "WARLOCK" ) then            
	    ShardBarFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
        ShardBarFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);

        local shardWidth = 36;
        local shardHeight = 24;
        
        for i=1,SHARD_BAR_NUM_SHARDS do
            local shard = _G["ShardBarFrameShard"..i];    
            local _, _, _, _, border = shard:GetRegions();
            border:Hide();
            
            local offset = (i - 1) * (shardWidth + 1);
            
            shard:ClearAllPoints();
            shard:SetPoint("LEFT", ShardBarFrame, "LEFT", 4 + offset, 0);
            
            shard:SetWidth(shardWidth);
            shard:SetHeight(shardHeight);
            
            --shard.shardFill:SetTexture("Interface\\AddOns\\CleanUI\\skins\\soulshard");
            shard.shardFill:SetTexture(CleanUIData.CUI_STATUSBAR);            
			shard.shardFill:SetVertexColor(1.0, 0.0, 0.8);
			
            shard.shardFill:SetTexCoord(0.0, 1.0, 0.0, 1.0);            
            shard.shardFill:ClearAllPoints();
            shard.shardFill:SetPoint("TOPLEFT", shard, "TOPLEFT", 0, 0);
            shard.shardFill:SetPoint("BOTTOMRIGHT", shard, "BOTTOMRIGHT", 0, 0);
        end
	elseif ( class == "DRUID" ) then   	    
	    EclipseBarFrame:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
        EclipseBarFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);        
	elseif ( class == "PALADIN" ) then                 
        PaladinPowerBar:SetAlpha(0.0);
	    
	    PaladinPowerBar:SetBackdrop( { 
            bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
            edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }
        });
        PaladinPowerBar:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
        
        CleanUI_SetWhiteStatusTexture(PaladinPowerBarGlowBGTexture, PaladinPowerBar);
        PaladinPowerBarGlowBGTexture:SetDrawLayer("ARTWORK");
        
        PaladinPowerBarBG:Hide();
            
        PaladinPowerBarRune1:ClearAllPoints();
        PaladinPowerBarRune1:SetPoint("LEFT", PaladinPowerBar, "LEFT", 12, 0);
	end
	
	PlayerFrameGroupIndicatorLeft:Hide();
	PlayerFrameGroupIndicatorRight:Hide();
	PlayerFrameGroupIndicatorMiddle:Hide();
    
    PlayerFrameGroupIndicator:SetFrameStrata("HIGH");
    PlayerFrameGroupIndicator:ClearAllPoints();
	PlayerFrameGroupIndicator:SetPoint("TOPLEFT", borderframe1, "TOPLEFT", -10, 15);
    
    PlayerFrameAlternateManaBarBackground:Hide();
    PlayerFrameAlternateManaBarBorder:Hide();
    
    CleanUI_UpdateShapeshiftForm();
end

local PALADIN_POWERBAR_HIDE_WAIT = 1.5;
local _palaWaitTimeSinceLast = 0;
function CleanUI_UpdatePaladinPowerBar(elapsed)

    local alpha1 = PaladinPowerBarRune1:GetAlpha();
    
    if (alpha1 == 0.0) then
        if (_palaWaitTimeSinceLast > 0) then
            _palaWaitTimeSinceLast = _palaWaitTimeSinceLast - elapsed;
            if (_palaWaitTimeSinceLast < 0) then
                PaladinPowerBar:SetAlpha(0.0);
            end
	    end
    else
        PaladinPowerBar:SetAlpha(1.0);
        _palaWaitTimeSinceLast = PALADIN_POWERBAR_HIDE_WAIT;
    end
end

function CleanUI_UpdateShapeshiftForm()
        
    PlayerFrameAlternateManaBar:SetWidth(PLAYER_BARWIDTH);    
    PlayerFrameAlternateManaBar:SetHeight(4);
	PlayerFrameAlternateManaBar:ClearAllPoints();
    PlayerFrameAlternateManaBar:SetPoint("TOPLEFT", PLAYER_BAROFFSET, -61);
    
    PlayerFrameAlternateManaBar:SetStatusBarColor(PowerBarColor["MANA"].r, PowerBarColor["MANA"].g, PowerBarColor["MANA"].b);
    
	if ( PlayerFrameAlternateManaBar:IsVisible() ) then
        PlayerFrameHealthBar:SetWidth(PLAYER_BARWIDTH);
        PlayerFrameHealthBar:SetHeight(20);  
        PlayerFrameHealthBar:SetPoint("TOPLEFT", PLAYER_BAROFFSET, -27);
        PlayerFrameHealthBarText:SetPoint("CENTER", 35, -2);
    
        PlayerFrameManaBar:SetWidth(PLAYER_BARWIDTH);    
        PlayerFrameManaBar:SetHeight(14);
        PlayerFrameManaBar:SetPoint("TOPLEFT", PLAYER_BAROFFSET, -47);
        PlayerFrameManaBarText:SetPoint("CENTER", 35, -19);
    else
        PlayerFrameHealthBar:SetWidth(PLAYER_BARWIDTH);
        PlayerFrameHealthBar:SetHeight(26);  
        PlayerFrameHealthBar:SetPoint("TOPLEFT", PLAYER_BAROFFSET, -27);
        PlayerFrameHealthBarText:SetPoint("CENTER", 35, -5);
    
        PlayerFrameManaBar:SetWidth(PLAYER_BARWIDTH);    
        PlayerFrameManaBar:SetHeight(12);
        PlayerFrameManaBar:SetPoint("TOPLEFT", PLAYER_BAROFFSET, -53);
        PlayerFrameManaBarText:SetPoint("CENTER", 35, -24);
    end
end

function CleanUI_MovePetIcons()
    
    PetFrame:SetWidth(100);
    PetFrame:SetHeight(48);
    PetFrame:SetHitRectInsets(0, 0, 0, 0);
    
    PetFrame:ClearAllPoints();
    PetFrame:SetPoint("TOPLEFT", 184, -68);
    
    PetFrame:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    PetFrame:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    PetFrameTexture:Hide();
    PetPortrait:Hide();
    
    PetName:ClearAllPoints();
	PetName:SetPoint("CENTER", 0, 15);
    
    PetFrameHealthBar:SetWidth(91);
    PetFrameHealthBar:SetHeight(18);  
    PetFrameHealthBar:ClearAllPoints();
    PetFrameHealthBar:SetPoint("TOP", PetFrame, "TOP", 0, -16);
    PetFrameHealthBarText:SetPoint("CENTER", 0, 0);
    
    PetFrameHealthBar:SetBackdrop(nil);
    
    PetFrameManaBar:SetWidth(91);    
    PetFrameManaBar:SetHeight(10);
    PetFrameManaBar:ClearAllPoints();
    PetFrameManaBar:SetPoint("TOP", PetFrame, "TOP", 0, -34);
    PetFrameManaBarText:SetPoint("CENTER", 0, -15);
    
    PetFrameManaBar:SetBackdrop(nil);
    
    PetHitIndicator:ClearAllPoints();
    PetHitIndicator:SetPoint("CENTER", PetFrame, "CENTER", 0, 0);
end

function CleanUI_MovePartyDefaultIcons(i)

    local offset = 80 * (i - 1);

    CleanUI_LoadFramePosition(_G["PartyMemberFrame"..i], 20, -160 - offset);
	
    _G["PartyMemberFrame"..i]:SetWidth(158);	
    _G["PartyMemberFrame"..i]:SetHeight(48)
    
	local borderframe1 = _G["CUI_PartyFrameBorder1"..i];
    if (not borderframe1) then
        borderframe1 = CreateFrame("Frame", "CUI_PartyFrameBorder1"..i, _G["PartyMemberFrame"..i]);
	end
	borderframe1:SetPoint("TOPLEFT", 0, 0);
    borderframe1:SetWidth(48);
    borderframe1:SetHeight(48);
    borderframe1:SetFrameStrata("BACKGROUND");
    
    borderframe1:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe1:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
	local borderframe2 = _G["CUI_PartyFrameBorder2"..i];
    if (not borderframe2) then
        borderframe2 = CreateFrame("Frame", "CUI_PartyFrameBorder2"..i, _G["PartyMemberFrame"..i]);
	end
	borderframe2:SetPoint("TOPRIGHT", 0, 0);
    borderframe2:SetWidth(112);
    borderframe2:SetHeight(48);
    borderframe2:SetFrameStrata("BACKGROUND");
    
    borderframe2:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe2:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    _G["PartyMemberFrame"..i.."Portrait"]:Hide();
    _G["PartyMemberFrame"..i.."Texture"]:Hide();
    _G["PartyMemberFrame"..i.."VehicleTexture"]:Hide();
    _G["PartyMemberFrame"..i.."Background"]:Hide();
    
    _G["PartyMemberFrame"..i.."Name"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."Name"]:SetPoint("CENTER", borderframe2, "CENTER", 0, 15);
    
    _G["PartyMemberFrame"..i.."RoleIcon"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."RoleIcon"]:SetPoint("TOPLEFT", 0, -42);
    
    _G["PartyMemberFrame"..i.."GuideIcon"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."GuideIcon"]:SetPoint("TOPLEFT", 0, -42);
    
    _G["PartyMemberFrame"..i.."MasterIcon"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."MasterIcon"]:SetPoint("TOPLEFT", 20, 5);
    
    _G["PartyMemberFrame"..i.."LeaderIcon"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."LeaderIcon"]:SetPoint("TOPLEFT", 0, 5);
    
    _G["PartyMemberFrame"..i.."PVPIcon"]:ClearAllPoints();
	_G["PartyMemberFrame"..i.."PVPIcon"]:SetPoint("CENTER", _G["PartyMemberFrame"..i], "RIGHT", 3, -1);
    
    _G["PartyMemberFrame"..i.."HealthBar"]:SetWidth(103);
    _G["PartyMemberFrame"..i.."HealthBar"]:SetHeight(18);  
    _G["PartyMemberFrame"..i.."HealthBar"]:ClearAllPoints();
    _G["PartyMemberFrame"..i.."HealthBar"]:SetPoint("LEFT", 50, -1);
    _G["PartyMemberFrame"..i.."HealthBar"]:SetFrameStrata("LOW");
    _G["PartyMemberFrame"..i.."HealthBarText"]:SetPoint("CENTER", _G["PartyMemberFrame"..i.."HealthBar"], "CENTER", 0,0);
    
    _G["PartyMemberFrame"..i.."ManaBar"]:SetWidth(103);    
    _G["PartyMemberFrame"..i.."ManaBar"]:SetHeight(10);
    _G["PartyMemberFrame"..i.."ManaBar"]:ClearAllPoints();
    _G["PartyMemberFrame"..i.."ManaBar"]:SetPoint("LEFT", 50, -15);
    _G["PartyMemberFrame"..i.."ManaBar"]:SetFrameStrata("LOW");
    _G["PartyMemberFrame"..i.."ManaBarText"]:SetPoint("CENTER", _G["PartyMemberFrame"..i.."ManaBar"], "CENTER", 0, 0);
    
    _G["PartyMemberFrame"..i.."Debuff1"]:SetPoint("TOPLEFT", 59, -50);
    
    CleanUI_MovePartyDefaultPetIcons(i);
end

function CleanUI_PartyMemberFrame_UpdatePet(self, id)
	if ( not id ) then
		id = self:GetID();
	end
	
    _G["PartyMemberFrame"..id.."PetFrame"]:ClearAllPoints();
	_G["PartyMemberFrame"..id.."PetFrame"]:SetPoint("TOPLEFT", _G["PartyMemberFrame"..id], "TOPRIGHT", -2, 0);
    _G["PartyMemberFrame"..id.."PetFrame"]:SetWidth(75);
    _G["PartyMemberFrame"..id.."PetFrame"]:SetHeight(48);  
end

function CleanUI_MovePartyDefaultPetIcons(i)
    
    _G["PartyMemberFrame"..i.."PetFrame"]:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    _G["PartyMemberFrame"..i.."PetFrame"]:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    _G["PartyMemberFrame"..i.."PetFramePortrait"]:Hide();
    _G["PartyMemberFrame"..i.."PetFrameTexture"]:Hide();
    
    _G["PartyMemberFrame"..i.."PetFrame"]:SetFrameStrata("LOW");
    
    CleanUI_PartyMemberFrame_UpdatePet(nil, i);
    
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetWidth(66);
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetHeight(18);  
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:ClearAllPoints();
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetPoint("CENTER", 0, -1);
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetFrameStrata("LOW");  
    
    _G["PartyMemberFrame"..i.."PetFrameHealthBar"]:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    _G["PartyMemberFrame"..i.."PetFrameDebuff1"]:SetPoint("TOPLEFT", 7, -50);
    
    local pet = "partypet"..i;
    
    if (UnitExists(pet)) then
        local petname = UnitName(pet);
        
        if (petname and _G["CUI_Party"..i.."PetName"]) then
            _G["CUI_Party"..i.."PetName"]:SetText(petname);
            _G["CUI_Party"..i.."PetName"]:Show();
        end
    else  
        if (_G["CUI_Party"..i.."PetName"]) then
            _G["CUI_Party"..i.."PetName"]:SetText("");  
            _G["CUI_Party"..i.."PetName"]:Hide(); 
        end
    end
end

function CleanUI_MoveTargetIcons()
  
    TargetFrame:SetWidth(232);
    TargetFrame:SetHeight(105);
    TargetFrame:SetHitRectInsets(165, 0, 0, 37);
        
    CleanUI_LoadFramePosition(TargetFrame, 300, -10);
    
    TargetFrame.powerBarAlt:ClearAllPoints(); 
    TargetFrame.powerBarAlt:SetPoint("LEFT", TargetFrame, "RIGHT", 0, 5);
    
	local borderframe1 = _G["CUI_TargetFrameBorder1"];
    if (not borderframe1) then
        borderframe1 = CreateFrame("Frame", "CUI_TargetFrameBorder1", TargetFrame);
	end
	borderframe1:SetPoint("TOPLEFT", 0, 0);
    borderframe1:SetWidth(164);
    borderframe1:SetHeight(70);
    borderframe1:SetFrameStrata("BACKGROUND");
    
    borderframe1:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe1:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
	local borderframe2 = _G["CUI_TargetFrameBorder2"];
    if (not borderframe2) then
        borderframe2 = CreateFrame("Frame", "CUI_TargetFrameBorder2", TargetFrame);
	end
	borderframe2:SetPoint("TOPLEFT", borderframe1, "TOPRIGHT", -2, 0);
    borderframe2:SetWidth(70);
    borderframe2:SetHeight(70);
    borderframe2:SetFrameStrata("BACKGROUND");
    
    borderframe2:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe2:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    TargetFrameBackground:Hide();
    TargetFrameNameBackground:Hide();
    TargetFrameTextureFrameTexture:Hide();
    TargetFramePortrait:Hide();
    
    TargetFrameTextureFrameName:SetWidth(200);
    TargetFrameTextureFrameName:SetHeight(10);
    TargetFrameTextureFrameName:ClearAllPoints();
	TargetFrameTextureFrameName:SetPoint("TOP", borderframe1, "TOP", 0, -6);
	
    CUI_TargetInfo:ClearAllPoints(); 
    CUI_TargetInfo:SetPoint("TOP", borderframe1, "TOP", 0, -16);
	
    TargetFrameNumericalThreat:SetWidth(70);
    TargetFrameNumericalThreat:ClearAllPoints(); 
    TargetFrameNumericalThreat:SetPoint("TOP", borderframe2, "TOP", 0, -3);
	
	for i, child in ipairs({TargetFrameNumericalThreat:GetRegions()}) do
	    if (not child:GetName()) then
	        child:SetTexture();
	    end
	end
    
    TargetFrameHealthBar:SetWidth(TARGET_BARWIDTH);
    TargetFrameHealthBar:SetHeight(26); 
    TargetFrameHealthBar:ClearAllPoints(); 
    TargetFrameHealthBar:SetPoint("TOPLEFT", 5, -27);
    
    TargetFrameTextureFrameHealthBarText:ClearAllPoints(); 
    TargetFrameTextureFrameHealthBarText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0);
    
    TargetFrameManaBar:SetWidth(TARGET_BARWIDTH);    
    TargetFrameManaBar:SetHeight(12);
    TargetFrameManaBar:ClearAllPoints(); 
    TargetFrameManaBar:SetPoint("TOPLEFT", 5, -53);
    
    TargetFrameTextureFrameManaBarText:ClearAllPoints(); 
    TargetFrameTextureFrameManaBarText:SetPoint("CENTER", TargetFrameManaBar, "CENTER", 0, 0);
    
    TargetFrameTextureFrameLeaderIcon:ClearAllPoints(); 
    TargetFrameTextureFrameLeaderIcon:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", 5, -5);
    
    TargetFrameTextureFrameLevelText:ClearAllPoints(); 
    TargetFrameTextureFrameLevelText:SetPoint("TOPRIGHT", borderframe2, "TOPRIGHT", -5, -5);
    
    TargetFrameTextureFrameHighLevelTexture:ClearAllPoints(); 
    TargetFrameTextureFrameHighLevelTexture:SetPoint("TOPRIGHT", borderframe2, "TOPRIGHT", -5, -5);
    
    TargetFrameTextureFrameRaidTargetIcon:SetWidth(20);    
    TargetFrameTextureFrameRaidTargetIcon:SetHeight(20);
    TargetFrameTextureFrameRaidTargetIcon:ClearAllPoints(); 
    TargetFrameTextureFrameRaidTargetIcon:SetPoint("BOTTOMRIGHT", borderframe2, "BOTTOMRIGHT", -4, 5);
    
    TargetFrameTextureFramePVPIcon:ClearAllPoints(); 
    TargetFrameTextureFramePVPIcon:SetPoint("CENTER", borderframe2, "RIGHT", 8, -12);
    
    TargetFrameTextureFrameQuestIcon:ClearAllPoints(); 
    TargetFrameTextureFrameQuestIcon:SetPoint("CENTER", borderframe1, "RIGHT", 0, 0);
    
    TargetFrameTextureFrameDeadText:ClearAllPoints(); 
    TargetFrameTextureFrameDeadText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0);
    
    CleanUI_MoveTargetOfTargetIcons();
    CleanUI_SetSpellbarAspect(TargetFrameSpellBar);
end

function CleanUI_MoveTargetOfTargetIcons()
    TargetFrameToT:SetWidth(112);
    TargetFrameToT:SetHeight(48);
    TargetFrameToT:SetHitRectInsets(0, 0, 0, 0);
    
    TargetFrameToT:ClearAllPoints();
    TargetFrameToT:SetPoint("TOPLEFT", 120, -68);
    
    TargetFrameToT:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    TargetFrameToT:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
	
    TargetFrameToTPortrait:Hide();
    TargetFrameToTBackground:Hide();
    TargetFrameToTTextureFrameTexture:Hide();
    
    TargetFrameToTTextureFrameName:ClearAllPoints();
	TargetFrameToTTextureFrameName:SetPoint("CENTER", 0, 14);
	TargetFrameToTTextureFrameName:SetJustifyH("CENTER");
    
    TargetFrameToTHealthBar:SetWidth(103);
    TargetFrameToTHealthBar:SetHeight(18);  
    TargetFrameToTHealthBar:ClearAllPoints();
    TargetFrameToTHealthBar:SetPoint("CENTER", 0, -1);
    
    TargetFrameToTManaBar:SetWidth(103);    
    TargetFrameToTManaBar:SetHeight(10);
    TargetFrameToTManaBar:ClearAllPoints();
    TargetFrameToTManaBar:SetPoint("CENTER", 0, -15);
    
    TargetFrameToTTextureFrameDeadText:ClearAllPoints(); 
    TargetFrameToTTextureFrameDeadText:SetPoint("CENTER", TargetFrameToTHealthBar, "CENTER", 0, 0);
end

function CleanUI_MoveFocusIcons()
    local fullsize = GetCVarBool("fullSizeFocusFrame");
    
    FocusFrame:SetWidth(232);
    FocusFrame:SetHeight(105);
    FocusFrame:SetHitRectInsets(165, 0, 0, 37);
    
    CleanUI_LoadFramePosition(FocusFrame, 560, -10);
    
    FocusFrame.powerBarAlt:ClearAllPoints(); 
    FocusFrame.powerBarAlt:SetPoint("LEFT", FocusFrame, "RIGHT", 0, 5);
    
	local borderframe1 = _G["CUI_FocusFrameBorder1"];
    if (not borderframe1) then
        borderframe1 = CreateFrame("Frame", "CUI_FocusFrameBorder1", FocusFrame);
	end
	borderframe1:SetPoint("TOPLEFT", 0, 0);
    borderframe1:SetWidth(164);
    borderframe1:SetHeight(70);
    borderframe1:SetFrameStrata("BACKGROUND");
    
    borderframe1:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe1:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
	local borderframe2 = _G["CUI_FocusFrameBorder2"];
    if (not borderframe2) then
        borderframe2 = CreateFrame("Frame", "CUI_FocusFrameBorder2", FocusFrame);
	end
	borderframe2:SetPoint("TOPLEFT", borderframe1, "TOPRIGHT", -2, 0);
    borderframe2:SetWidth(70);
    borderframe2:SetHeight(70);
    borderframe2:SetFrameStrata("BACKGROUND");
    
    borderframe2:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe2:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
    
    FocusFrameBackground:Hide();
    FocusFrameNameBackground:Hide();
    FocusFrameTextureFrameTexture:Hide();
    FocusFramePortrait:Hide();
    
    FocusFrameTextureFrameName:SetWidth(200);
    FocusFrameTextureFrameName:SetHeight(10);
    FocusFrameTextureFrameName:ClearAllPoints();
	FocusFrameTextureFrameName:SetPoint("TOP", borderframe1, "TOP", 0, -6);
	
    CUI_FocusInfo:ClearAllPoints(); 
    CUI_FocusInfo:SetPoint("TOP", borderframe1, "TOP", 0, -16);
    
    FocusFrameNumericalThreat:SetWidth(70);
    FocusFrameNumericalThreat:ClearAllPoints(); 
    FocusFrameNumericalThreat:SetPoint("TOP", borderframe2, "TOP", 0, -3);
	
	for i, child in ipairs({FocusFrameNumericalThreat:GetRegions()}) do
	    if (not child:GetName()) then
	        child:SetTexture();
	    end
	end
	
    FocusFrameHealthBar:SetWidth(TARGET_BARWIDTH);
    FocusFrameHealthBar:SetHeight(26); 
    FocusFrameHealthBar:ClearAllPoints(); 
    FocusFrameHealthBar:SetPoint("TOPLEFT", 5, -27);
    
    FocusFrameTextureFrameHealthBarText:ClearAllPoints(); 
    FocusFrameTextureFrameHealthBarText:SetPoint("CENTER", FocusFrameHealthBar, "CENTER", 0, 0);
    
    FocusFrameManaBar:SetWidth(TARGET_BARWIDTH);    
    FocusFrameManaBar:SetHeight(12);
    FocusFrameManaBar:ClearAllPoints(); 
    FocusFrameManaBar:SetPoint("TOPLEFT", 5, -53);
    
    FocusFrameTextureFrameManaBarText:ClearAllPoints(); 
    FocusFrameTextureFrameManaBarText:SetPoint("CENTER", FocusFrameManaBar, "CENTER", 0, 0);
    
    FocusFrameTextureFrameLeaderIcon:ClearAllPoints(); 
    FocusFrameTextureFrameLeaderIcon:SetPoint("TOPLEFT", FocusFrame, "TOPLEFT", 5, -5);
    
    FocusFrameTextureFrameLevelText:ClearAllPoints(); 
    FocusFrameTextureFrameLevelText:SetPoint("TOPRIGHT", borderframe2, "TOPRIGHT", -5, -5);
    
    FocusFrameTextureFrameHighLevelTexture:ClearAllPoints(); 
    FocusFrameTextureFrameHighLevelTexture:SetPoint("TOPRIGHT", borderframe2, "TOPRIGHT", -5, -5);
    
    FocusFrameTextureFrameRaidTargetIcon:SetWidth(20);    
    FocusFrameTextureFrameRaidTargetIcon:SetHeight(20);
    FocusFrameTextureFrameRaidTargetIcon:ClearAllPoints(); 
    FocusFrameTextureFrameRaidTargetIcon:SetPoint("BOTTOMRIGHT", borderframe2, "BOTTOMRIGHT", -4, 5);
    
    FocusFrameTextureFramePVPIcon:ClearAllPoints(); 
    FocusFrameTextureFramePVPIcon:SetPoint("CENTER", borderframe2, "RIGHT", 8, -12);
    
    FocusFrameTextureFrameQuestIcon:ClearAllPoints(); 
    FocusFrameTextureFrameQuestIcon:SetPoint("CENTER", borderframe2, "RIGHT", 8, -12);
    
    FocusFrameTextureFrameDeadText:ClearAllPoints(); 
    FocusFrameTextureFrameDeadText:SetPoint("CENTER", FocusFrameHealthBar, "CENTER", 0, 0);
    
    CleanUI_MoveTargetOfFocusIcons();
    CleanUI_SetSpellbarAspect(FocusFrameSpellBar);
end

function CleanUI_MoveTargetOfFocusIcons()	
    local fullsize = GetCVarBool("fullSizeFocusFrame");
    
    FocusFrameToT:SetWidth(112);
    FocusFrameToT:SetHeight(48);
    FocusFrameToT:SetHitRectInsets(0, 0, 0, 0);
    
    FocusFrameToT:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    FocusFrameToT:SetBackdropColor(0.0, 0.0, 0.0, 1.0);
	
    FocusFrameToTPortrait:Hide();
    FocusFrameToTBackground:Hide();
    FocusFrameToTTextureFrameTexture:Hide();
    
    FocusFrameToTTextureFrameName:ClearAllPoints();
	FocusFrameToTTextureFrameName:SetPoint("CENTER", 0, 14);
	FocusFrameToTTextureFrameName:SetJustifyH("CENTER");
    
    FocusFrameToTHealthBar:SetWidth(103);
    FocusFrameToTHealthBar:SetHeight(18);  
    FocusFrameToTHealthBar:ClearAllPoints();
    FocusFrameToTHealthBar:SetPoint("CENTER", 0, -1);
    
    FocusFrameToTManaBar:SetWidth(103);    
    FocusFrameToTManaBar:SetHeight(10);
    FocusFrameToTManaBar:ClearAllPoints();
    FocusFrameToTManaBar:SetPoint("CENTER", 0, -15);
    
    FocusFrameToTTextureFrameDeadText:ClearAllPoints(); 
    FocusFrameToTTextureFrameDeadText:SetPoint("CENTER", FocusFrameToTHealthBar, "CENTER", 0, 0);
    
    if (fullsize) then
        FocusFrameToT:SetScale(1.0);
    
        FocusFrameToT:ClearAllPoints();
        FocusFrameToT:SetPoint("TOPLEFT", 120, -68);
    else
        FocusFrameToT:SetScale(0.9);
    
        FocusFrameToT:ClearAllPoints();
        FocusFrameToT:SetPoint("TOPLEFT", 95, -76);
    end
end

function CleanUI_BossTargetFrame_OnLoad(self, unit, event)
    if (CleanUIData.CHANGE_BOSSFRAMES == 1) then 
        CleanUI_BossTargetIcons(self);
    end
end

function CleanUI_BossTargetIcons(frame)
	
	frame:SetScale(0.8);    
    frame:SetFrameStrata("LOW");
    
    local borderframe = _G["CUI_"..frame:GetName().."BorderFrame"];
    
    if (not borderframe) then
        borderframe = CreateFrame("Frame", "CUI_"..frame:GetName().."BorderFrame", frame);
    end
    
    borderframe:SetWidth(138);
    borderframe:SetHeight(65);
    borderframe:ClearAllPoints();
    borderframe:SetPoint("TOPLEFT", 0, 0);
    borderframe:SetFrameStrata("BACKGROUND");
    
    borderframe:SetBackdrop( { 
        bgFile = CleanUIData.CUI_FRAME_BACKGROUND, 
        edgeFile = CleanUIData.CUI_FRAME_BORDER, tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    });
    borderframe:SetBackdropColor(0.0, 0.0, 0.0, 0.5);
    
    CleanUI_SetWhiteStatusTexture(_G[frame:GetName().."Flash"], borderframe);
    _G[frame:GetName().."Flash"]:SetDrawLayer("OVERLAY");
        
    _G[frame:GetName().."Background"]:Hide();
    _G[frame:GetName().."NameBackground"]:Hide();
    _G[frame:GetName().."TextureFrameTexture"]:Hide();
    _G[frame:GetName().."Portrait"]:Hide();
    
    _G[frame:GetName().."TextureFrameName"]:SetWidth(130);
    _G[frame:GetName().."TextureFrameName"]:SetHeight(10);
    _G[frame:GetName().."TextureFrameName"]:ClearAllPoints();
	_G[frame:GetName().."TextureFrameName"]:SetPoint("TOP", borderframe, "TOP", 0, -7);
    
    _G[frame:GetName().."HealthBar"]:SetWidth(130);
    _G[frame:GetName().."HealthBar"]:SetHeight(26); 
    _G[frame:GetName().."HealthBar"]:ClearAllPoints(); 
    _G[frame:GetName().."HealthBar"]:SetPoint("TOPLEFT", 4, -22);
    _G[frame:GetName().."TextureFrameHealthBarText"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameHealthBarText"]:SetPoint("CENTER", _G[frame:GetName().."HealthBar"], "CENTER", 0, 0);
    
    _G[frame:GetName().."ManaBar"]:SetWidth(130);    
    _G[frame:GetName().."ManaBar"]:SetHeight(12);
    _G[frame:GetName().."ManaBar"]:ClearAllPoints(); 
    _G[frame:GetName().."ManaBar"]:SetPoint("TOPLEFT", 4, -48);
    _G[frame:GetName().."TextureFrameManaBarText"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameManaBarText"]:SetPoint("CENTER", _G[frame:GetName().."ManaBar"], "CENTER", 0, 0);
    
    _G[frame:GetName().."TextureFrameLeaderIcon"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameLeaderIcon"]:SetPoint("TOPLEFT", frame, "TOPLEFT", 5, -5);
    
    _G[frame:GetName().."TextureFrameLevelText"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameLevelText"]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -100, -5);
    
    _G[frame:GetName().."TextureFrameHighLevelTexture"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameHighLevelTexture"]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -100, -5);
    
    _G[frame:GetName().."TextureFrameRaidTargetIcon"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameRaidTargetIcon"]:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -100, -35);
    
    _G[frame:GetName().."TextureFramePVPIcon"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFramePVPIcon"]:SetPoint("CENTER", frame, "RIGHT", 8, 2);
    
    _G[frame:GetName().."TextureFrameDeadText"]:ClearAllPoints(); 
    _G[frame:GetName().."TextureFrameDeadText"]:SetPoint("CENTER", _G[frame:GetName().."HealthBar"], "CENTER", 0, 0);
    _G[frame:GetName().."TextureFrameDeadText"]:Hide();
end

local movingBossTargetFrames = false;

function CleanUI_MoveBossTargetFrames()

    if (movingBossTargetFrames) then
        return;
    end

    movingBossTargetFrames = true;
    
    Boss1TargetFrame:ClearAllPoints(); 
    Boss1TargetFrame:SetPoint("TOPRIGHT", "MinimapCluster", "BOTTOMRIGHT", -100, -75);
    
    movingBossTargetFrames = false;
end

function CleanUI_SetSpellbarAspect(self)

    self:SetWidth(205);
    self:SetHeight(20);

	local spellBarName = self:GetName();

	local frameText = _G[spellBarName.."Text"];
	if ( frameText ) then
		frameText:SetFontObject(SystemFont_Shadow_Small);
		frameText:ClearAllPoints();
		frameText:SetPoint("TOP", self, "TOP", 0, -1);
	end

	local frameBorder = _G[spellBarName.."Border"];
	if ( frameBorder ) then
		frameBorder:SetTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	end
	
	local frameIcon = _G[spellBarName.."Icon"];
	if ( frameIcon ) then
        frameIcon:SetWidth(22);
        frameIcon:SetHeight(22);
		frameIcon:ClearAllPoints();
		frameIcon:SetPoint("RIGHT", self, "LEFT", 0, 0);
    end

	local frameBorderShield = _G[spellBarName.."BorderShield"];
	if ( frameBorderShield ) then
		frameBorderShield:SetTexture("Interface\\AddOns\\CleanUI\\skins\\empty");
	end

	local frameFlash = _G[spellBarName.."Flash"];
	if ( frameFlash ) then
		frameFlash:SetTexture("Interface\\AddOns\\CleanUI\\skins\\spellbar_flash");
		frameFlash:ClearAllPoints();
        frameFlash:SetPoint("TOPLEFT", self, "TOPLEFT", 2, -2);
        frameFlash:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", -2, 2);
	end

	local frameSpark = _G[spellBarName.."Spark"];
	if ( frameSpark ) then
		frameSpark:SetWidth(40);
		frameSpark:SetHeight(40);
	end
end

function CleanUI_SetTexture(object, texture)
	object:SetNormalTexture(texture);
	object:SetPushedTexture(texture);
end

function CleanUI_SetTextureCoords(object, index)
	object:GetNormalTexture():SetTexCoord(CUI_RAIDICONS[index].left,CUI_RAIDICONS[index].right,CUI_RAIDICONS[index].top,CUI_RAIDICONS[index].bottom);
	object:GetPushedTexture():SetTexCoord(CUI_RAIDICONS[index].left,CUI_RAIDICONS[index].right,CUI_RAIDICONS[index].top,CUI_RAIDICONS[index].bottom);
end

function CleanUI_RaidIconUpdate()  
    --pet
    
    local button = getglobal("CleanUIPetRaidIcon");

    if (UnitExists("pet") == 1 and _G["PetFrame"]:IsVisible()) then		
        
        if (UnitExists("pettarget") == 1) then    
            local index = GetRaidTargetIndex("pettarget");
            
            if (index == nil or index == 0) then
                CleanUI_SetTexture(button, "Interface\\AddOns\\CleanUI\\skins\\assist");
                CleanUI_SetTextureCoords(button, 9);
            else
                CleanUI_SetTexture(button, CUI_RAIDICON_FILE);
                CleanUI_SetTextureCoords(button, index);
            end
        else
            CleanUI_SetTexture(button, CUI_RAIDICON_FILE);
            CleanUI_SetTextureCoords(button, 0);
        end
    end

    -- party
	for i=1, 4, 1 do
		local button = getglobal("CleanUIParty"..i.."RaidIcon");
	
		if (UnitExists("party"..i) == 1 and _G["PartyMemberFrame"..i]:IsVisible()) then
		    
		    if (UnitExists("party"..i.."target") == 1) then		    
		        local index = GetRaidTargetIndex("party"..i.."target");
		    
                if (index == nil or index == 0) then
                    CleanUI_SetTexture(button, "Interface\\AddOns\\CleanUI\\skins\\assist");
                    CleanUI_SetTextureCoords(button, 9);
                else
                    CleanUI_SetTexture(button, CUI_RAIDICON_FILE);
                    CleanUI_SetTextureCoords(button, index);
                end
            else
                CleanUI_SetTexture(button, CUI_RAIDICON_FILE);
                CleanUI_SetTextureCoords(button, 0);
            end
		end
	end
end